#!/bin/perl
#Augment our rule file with the appropriate number of spots for BING rules
#Using a bing phrase table as template.

use strict;
use Getopt::Long;

my $bingtable = '';
die if !GetOptions('bingtable=s' => \$bingtable);

if ($bingtable eq ''){
    print "ERROR: no bingtable provided\n";
    exit;
}

my $template = `head -n 1 $bingtable`;
my @parts = split(/\#/, $template);
my $scores =  $parts[3];
chomp($scores);
$scores =~ s/^\s+//go;
$scores =~ s/\s+$//go;
$scores =~ s/[a-zA-Z0-9\-e\.]+/0/g;

# add a 0.000 for a isBing feature
while (<STDIN>){
    my $line = $_;
    chomp($line);
    print $line." 0.000 ".$scores, "\n";
}
