#!perl 
#Make a translation model with the src and target data sets


my $DATAFILE_SRC  = $ARGV[0];
my $DATAFILE_TGT  = $ARGV[1];
my $VOCFILE  = $ARGV[2];
my $OUTFILE  = $ARGV[3];

#my $GraphAlign = "/nfs/dish8/Andreas/STTK2K4/bin/GraphAlignO";
my $GraphAlign = "GraphAlignO";


CreateTM($OUTFILE, $DATAFILE_SRC, $DATAFILE_TGT, $VOCFILE); 

sub CreateTM {
    my ($fileName, $sourceCorpus, $targetCorpus, $baseVoc) = @_;    


    my $taggedFileName = $fileName;
    
    #run IBM1 alignment
    my $I = "10.0";
#    my $L = "0.01";
    my $L = "0.00001";

    #OLD STYLE
    #my $runLine = "$GraphAlign --Model IBM1 --NumberOfIterations $I --SumProbForUnseen $L --SourceText ".$sourceCorpus." --TargetText ".$targetCorpus." --ReadOneByOne 1.0 --SourceVoc ".$baseVoc." --TargetVoc ".$baseVoc." --TOutFile ".$taggedFileName." --DisplayLexicon 0.0 --LexiconOutFile ".$taggedFileName.".Lex --Verbose 0.0";

    my $runLine = "$GraphAlign --Model IBM1 --NumberOfIterations $I --SumProbForUnseen $L --SourceText ".$sourceCorpus." --TargetText ".$targetCorpus." --SourceVoc ".$baseVoc." --TargetVoc ".$baseVoc." --TOutFile ".$taggedFileName." --DisplayLexicon 0.0 --LexiconOutFile ".$taggedFileName.".Lex --Verbose 0.0 > $taggedFileName.log";
    print "============== REGEN IBM1 Alignment ==========================\n";
    print $runLine, "\n";
    `$runLine`;
   
    #run IBM1 alignment reversed
    print "============== REGEN IBM1 Alignment Reversed =================\n";

    $runLine = "$GraphAlign --Model IBM1 --NumberOfIterations $I --SumProbForUnseen $L --SourceText ".$targetCorpus." --TargetText ".$sourceCorpus." --SourceVoc ".$baseVoc." --TargetVoc ".$baseVoc." --TOutFile ".$taggedFileName.".rev --DisplayLexicon 0.0 --LexiconOutFile ".$taggedFileName.".rev.Lex --Verbose 0.0 > $taggedFileName.rev.log";

    print $runLine, "\n";
    `$runLine`;
}


