#!/bin/csh -f
#Assume that the file is already IN GB2312 cause we ran segmentation like this

set FILE = $1

#setenv variables to be able to use java for the standford segmenter
setenv JDK_HOME  /afs/cs.cmu.edu/usr/nbach/jdk1.5.0_05
setenv JAVA_HOME /afs/cs.cmu.edu/usr/nbach/jdk1.5.0_05
setenv CLASSPATH /afs/cs.cmu.edu/usr/nbach/jdk1.5.0_05/jre/lib
setenv PATH  ${JDK_HOME}/bin/:${PATH}

alias java='/afs/cs.cmu.edu/usr/nbach/jdk1.5.0_05/bin/java'
alias javac='/afs/cs.cmu.edu/usr/nbach/jdk1.5.0_05/bin/javac'

set PERL = /nfs/islpc7_1/Andreas/ActivePerl-5.8/bin/perl

set REMOVE_PUNCT = 1

#run the segmenter on the GB file
echo "Segmenting $FILE PATH $PATH"
which java
set CURRENT = `pwd`
#cd /project/Gale/Translation/Data/Rosetta-DryRun-April2006/FOUO/seg/chinesesegmenter-2006-05-16/
#./segment.sh ctb $FILE GB2312 > $FILE.seg
cd $CURRENT

set SCRIPT = /nfs/islpc7_2/ashishv/iwslt/data/scripts/tagging/IBM_CH_Tagging/

set FILE = $FILE.seg
echo "Preprocessing on $FILE"

#remove punctuation on the source side (but this script assumes utf8 so this doe NOTHING now)
if ($REMOVE_PUNCT) then
echo "Removing punctuation"
cat $FILE | perl /project/IWSLT/IWSLT-2006/Chinese-English/Downloaded-Data/CE/tools/ppChinese.no_punc.pl > $FILE.rmpunct
set FILE = $FILE.rmpunct
endif


#first deal with the PT (chinese number) issues AND to joy's unihan'ing AND separate such uni-han chars from chinese words
#dont make the PT occur if its a lone word, so that we know we must join back to a real word
echo "PT and unihan and ascii time conversion"
setenv LC_ALL C
cat $FILE | sed 's/\([^ ]\)\xB5\xE3 /\1 PTTAG /g; s/\s+/ /g;' | perl5 /afs/cs.cmu.edu/user/joy/Demo/PreprocScript/two2one-gb.perl  | $PERL RemovePunctASCII.pl  | perl ConvertASCIITimes.pl > $FILE.uni

set FILEGB = $FILE.uni

#now convert it to utf8 - this doesnt work, errors in the conversion
#iconv -t UTF8 -f CSGB2312 $FILEGB > $FILEGB.utf8
echo "Conversion to utf8 followed by Le removal"
cat $FILEGB | ./gb2312toutf8 | perl RemoveLeUTF8.pl > $FILEGB.utf8

set FILE = $FILEGB.utf8

#if you want a non-tagged text, you should just take the utf8 file, and call ShovePTBackUTF8.sh on it

$PERL ${SCRIPT}/ch_unihan3_class.pl < ${FILE} > ${FILE}.class
$PERL ${SCRIPT}/ch_unihan3_simpl_norm.pl < ${FILE}.class > ! ${FILE}.class.norm
cat ${FILE}.class.norm | $PERL ${SCRIPT}/ch_trans_new.pl 1 | sed 's/^ //g; s/ $//g;' | ./ShovePTBackUTF8.sh > ! ${FILE}.class.norm.trans
