#!/bin/tcsh -f
#Note: PhrasalFeaturCount = 0 (since there the lexicons were not used)
set IN = $1

#settings for filtering
set PROB = 0.03
set MINNONLEX = 100
set MINLEX = 20
set EXPNAME = "tcstar-remccd"

set OUTFILE =  `echo "$IN" | replace '.gz' '.filtdb'`
set OUTFILE = "${OUTFILE}.${EXPNAME}.pr${PROB}.minnon${MINNONLEX}.minlex${MINLEX}"
echo "Producing:  ${OUTFILE}"
set A = /nfs/islpc7_2/ashishv/

set F2N = /data/SMT2/TC_STAR/ashishv/baseline-matched/refined.emptyback.f2n
set N2F = /data/SMT2/TC_STAR/ashishv/baseline-matched/refined.emptyback.n2f
set REST = /people/ashishv0/samt/tcstar/test07dev07test06.utf8.segmented
set NUMRULES = /people/ashishv0/samt/tcstar/asr07test07dev07test06.utf8.segmented.trans.boostedrules

zcat $IN | cat - ${NUMRULES} | filterrules.pl --UseNULL --UseRefinedIBM1ProbEstimate --noAllowAbstractRules --cachesize 300 --tmpdir=/tmp --MeanTargetSourceRatio=1.36 --LexicalWeightFile ${N2F} -LexicalWeightFileReversed ${F2N} --minlexsourcecondrflexicalrules=${PROB} --minlexsourcecondrfnonlexicalrules=${PROB} --minoccurrencecountlexicalrules=${MINLEX} --minoccurrencecountnonlexicalrules=${MINNONLEX} --MaxSourcePhraseLength 100 -r ${REST}  --HasSimpleCount=1 --PhrasalFeatureCount=12 --RemoveSourcePunctuation --nokeepunbalancedpunctuationrules -o ${OUTFILE}
echo "${OUTFILE}"
