#!/usr/bin/env perl
#Do some simple analysis of the phrase table:
use Getopt::Long;
my %altsPerSource = ();
my $sortRuleIndex = 4;
my $DoExp = 1;
die if !GetOptions('SortIndex=s' => \$sortRuleIndex, "DoExp!" => \$DoExp);

while (<STDIN>){
    my $rule = $_;
    chomp($rule);
    my @parts = split(/\s*\#\s*/, $_);
    
    my $src = $parts[0];
    my $tgt = $parts[1];
    my $cat = $parts[2];
    my $costs = $parts[3];
    my $aref = 	$altsPerSource{$src};
    #my $prule = join(' ', @parts[0..2]);

    if (defined($aref)){
	push(@$aref, $rule);
    }else{

	my @targets;
	push(@targets, $rule);
	$altsPerSource{$src} = \@targets;
    }
}

my @skeys = reverse sort{ scalar(@{$altsPerSource{$a}}) <=> scalar(@{$altsPerSource{$b}}) } keys %altsPerSource;
foreach my $src (@skeys){
    my %ruleMap;
    foreach my $rule (@{$altsPerSource{$src}}){
	my @parts = split(/\s*\#\s*/, $rule);
	my @costs = split(/ /,$parts[3]);
	#print "$src => COSTS:", join(' ',@costs), "\n";
	$ruleMap{$parts[0]."#".$parts[1]."#".$parts[2]} = $costs[$sortRuleIndex];
    }
    my @sortedKeys = sort { $ruleMap{$a} <=> $ruleMap{$b} } keys %ruleMap;
    
    
    print "$src => ";
    my $sanitySum = 0;
    foreach my $key (@sortedKeys){
	my $prob = ($DoExp) ? exp(-1*$ruleMap{$key}) : $ruleMap{$key};
	die "Prob = $prob was >1 or <0" if ($prob>1.01 || $prob <$prob);
	$sanitySum += $prob;
	print "\t$key # prob=",$prob," DoExp $DoExp\n";
    }
    print "$src => SANITY SUM : $sanitySum\n";

}
