#!/usr/bin/env perl
#Assumes that you have fixed all the parses and scores according to charniaknbest etc
use IO::File;
use Getopt::Long;
use strict;

my $N = 10;
my $parsepostfix = ".parses.fixed";
my $scorepostfix = ".scores.fixed";
die if !GetOptions("parsepostfix=s" => \$parsepostfix, 'scorepostfix=s' => \$scorepostfix, 'N=s' => \$N);

my @parsefd = map{ new IO::File("$_$parsepostfix", "r"); } 0..$N-1;
my @scorefd = map{ new IO::File("$_$scorepostfix", "r"); } 0..$N-1;

my $numlines = `wc -l 0$parsepostfix`;
chomp($numlines);
print STDERR "LINES $numlines\n";

for (my $l=0; $l<$numlines; $l++){
    my $fd1 = $parsefd[0];
    my $fd2 = $scorefd[0];
    my $lastparseline = <$fd1>;
    my $lastscoreline = <$fd2>;
    chomp($lastparseline);
    chomp($lastscoreline);
    my $all = "$lastparseline => $lastscoreline";
    if ($all =~ m/_fail/){
	print "_fail\n";
	next;
    }
    for (my $i=1; $i<$N; $i++){
	$fd1 = $parsefd[$i];
	$fd2 = $scorefd[$i];
	
	my $parseline = <$fd1>;
	my $scoreline = <$fd2>;
	chomp($parseline);
	chomp($scoreline);
	if ($scoreline eq $lastscoreline){
	    last;
	}else{
	    $all = $all." \# $parseline => $scoreline";
	    $lastscoreline = $scoreline;
	    $lastparseline = $parseline;
	}
    }
    print $all, "\n";
}
