#!/usr/bin/env perl
#Take a charniak n best file and create a set of n-best files
use IO::File;
use strict;

my $parsepostfix = ".parses";
my $scorepostfix = ".scores";

my $maxn = $ARGV[0];
my @parsefileset = map{ new IO::File("$_$parsepostfix", "w"); }0..$maxn-1;
my @scorefileset = map{ new IO::File("$_$scorepostfix", "w"); }0..$maxn-1;

my $count =0;
while (<STDIN>){
    if (m/^([0-9]+)\s+([0-9]+)/){
	$count++;
	if ($count % 1000 == 0){
	    print STDERR "Processing sent no: $count\n";
	}
	my $num = $1;
	my $snum = $2;

	$num = $num*2; #since we have to read neg log probs too!                                                                 
	my @num_lines = map scalar(<STDIN>), 1..$num;
	#print "LINES: ", join("\n", @num_lines), "\n";
	#have all the parses for this sentence, maybe less than we need
	my @probs = grep /^[0-9\.\-e]+$/, @num_lines;
	my @parses = grep /\(/, @num_lines;
	#ensure both parses and probs have enough elements
	while (scalar(@probs)!=$maxn){
	    push(@probs, $probs[-1]);
	}
	while (scalar(@parses)!=$maxn){
	    push(@parses, $parses[-1]);
	}
	#write them to the file
	for (my $i=0; $i<scalar(@parsefileset); $i++){
	    $parsefileset[$i]->print($parses[$i]);
	}
	for (my $i=0; $i<scalar(@scorefileset); $i++){
	    if ($parses[$i] =~ m/coolpunct/){
		$scorefileset[$i]->print("coolpunct_newline\n");
	    }else{
		$scorefileset[$i]->print($probs[$i]);
	    }
	}
	my $emptyLine = <STDIN>;
	$emptyLine =~ s/\s+//g;
	if ($emptyLine ne ''){
	    print STDERR "ERROR EmptyLine expected: found $emptyLine\n";
	    exit;
	}

    }else{
	if (m/_fail/){
	    my $fline = $_;
	    chomp($fline);
	    my $emptyLine = <STDIN>;
	    $emptyLine =~ s/\s+//g;
	    if ($emptyLine ne ''){
		print STDERR "ERROR EmptyLine expected: found $emptyLine\n";
		exit;
	    }
	    for (my $i=0; $i<scalar(@parsefileset); $i++){
		$parsefileset[$i]->print("$fline\n");
	    }
	    for (my $i=0; $i<scalar(@scorefileset); $i++){
		$scorefileset[$i]->print("$fline");
	    }
	}else{
	    print STDERR "ERROR Unknown line type $_ \n";
	    exit;
	}
    }
}
