#!/bin/bash
#Authors: zollmann, ashishv, initally from vogel
#Example Usage: condorsubmit.sh 1 exp1 "echo wow | replace 'w' 'W'>exp1.metalog"
# The output of the commands in quotes go to: exp1.log/err

#Uses the Job as an identifier and runs the Exe with arguments
#the Job.clog is the condor log file that we need to wait for in order to wait for this process to finish
#while Job.log is the actual log file
minmemory="$1"
Job="$2"
#if you give a full path for this Job argument, you can get in trouble when trying to create files like Condor./project/mylog
#so lets quickly alias this
JobName=`echo $Job | replace "\/" "-"`
echo "JobName $JobName"

#set CondorParams = "$2" # can be ''
CondorParams=""

#Creates an anonymous script
Exe=`which runexp-fromscript.sh`

shift
shift
#shift

PATH=  /nfs/islpc7_1/Andreas/ActivePerl-5.8/bin:$PATH
export PATH
echo PATH: $PATH
# create a script that executes all the rest on the caller's command line
echo "Running command: $@"
echo "$@" > $Job.runline

Dir=`pwd`
#echo "in      " $Dir
unset DISPLAY

Machine="islr0s2 islr0s4 islr0s6 islr0s8 islr0s10 islpc6 islpc12 islpc14 islpc10 islpc1 islpc3 islpc4 islpc11 caesar cow crassus moon pearl"
Machineline=`echo $Machine|perl -pe 's/ /.is.cs.cmu.edu\" \|\| Machine == \"/g , s/^/\( Machine == \"/g , s/\n/.is.cs.cmu.edu\" \)/g ;'`
echo "########################################"  > Condor.$JobName
echo "# Job: Condor."$Job     >> Condor.$JobName
echo "# Submitted on:" `date` >> Condor.$JobName
echo "# In directory:" `pwd`  >> Condor.$JobName
echo "########################################" >> Condor.$JobName
echo ""                     >> Condor.$JobName
echo "Executable = " $Exe   >> Condor.$JobName
#echo "Arguments  = " "$@"  >> Condor.$JobName
echo "Arguments  = " "$Job.runline"  >> Condor.$JobName
echo "Initialdir = " $Dir   >> Condor.$JobName
echo "Output     = " $Job.log >> Condor.$JobName
echo "Error      = " $Job.err >> Condor.$JobName
echo "Log        = " $Job.clog >> Condor.$JobName
echo "+SMTJob = True" >> Condor.$JobName
echo "Universe   = vanilla" >> Condor.$JobName
echo "notification = never" >> Condor.$JobName
echo "Getenv     = True"    >> Condor.$JobName
#echo "Rank       = KFLOPS"    >> Condor.$JobName
#echo "NiceUser = True" >> Condor.$JobName
echo 'Requirements = (Arch == "x86_64" || Arch == "INTEL") && Memory > '$minmemory ' && ' $Machineline >> Condor.$JobName
#echo 'Requirements = Memory >= '$minmemory >> Condor.$JobName
echo "SUSPEND    = False"    >> Condor.$JobName

echo ""                     >> Condor.$JobName
echo "Queue"                >> Condor.$JobName

cat Condor.$JobName

condor_submit $CondorParams Condor.$JobName

