#!/bin/bash
#Authors: zollmann, ashishv, initally from vogel
#Example Usage: condorsubmit.sh 1 exp1 "echo wow | replace 'w' 'W'>exp1.metalog"
# The output of the commands in quotes go to: exp1.log/err

#Uses the Job as an identifier and runs the Exe with arguments
#the Job.clog is the condor log file that we need to wait for in order to wait for this process to finish
#while Job.log is the actual log file
maxdays="$1"
Job="$2"
#if you give a full path for this Job argument, you can get in trouble when trying to create files like Condor./project/mylog
#so lets quickly alias this
JobName=`echo $Job | replace "\/" "-"`
echo "JobName $JobName"

#set CondorParams = "$2" # can be ''
CondorParams=""

#Creates an anonymous script
Exe=`which runexp-fromscript.sh`

shift
shift
#shift

# create a script that executes all the rest on the caller's command line
echo "Running command: $@"
echo "$@" > $Job.runline

#  Machine="islr0s0 islr0s1 islr0s2 islr0s3 islr0s4 islr0s5 islr0s6 islr0s7 islr0s8 islpc9"

if [ $maxdays -le 21 ]; then  m=islpc9 ; fi
if [ $maxdays -le 14 ]; then  m="islr0s8 $m" ; fi
if [ $maxdays -le 7 ]; then  m="islr0s7 $m" ; fi
if [ $maxdays -le 6 ]; then  m="islr0s6 $m" ; fi
if [ $maxdays -le 5 ]; then  m="islr0s5 $m" ; fi
if [ $maxdays -le 4 ]; then  m="islr0s4 $m" ; fi
if [ $maxdays -le 3 ]; then  m="islr0s3 $m" ; fi
if [ $maxdays -le 2 ]; then  m="islr0s2 $m" ; fi
if [ $maxdays -le 1 ]; then  m="islr0s0 islr0s1 $m" ; fi

Machineline=`echo $m|perl -pe 's/ /.is.cs.cmu.edu\" \|\| Machine == \"/g , s/^/\( Machine == \"/g , s/\n/.is.cs.cmu.edu\" \)/g ;'`

echo $Machineline

Dir=`pwd`
#echo "in      " $Dir
unset DISPLAY

echo "########################################"  > Condor.$JobName
echo "# Job: Condor."$Job     >> Condor.$JobName
echo "# Submitted on:" `date` >> Condor.$JobName
echo "# In directory:" `pwd`  >> Condor.$JobName
echo "########################################" >> Condor.$JobName
echo ""                     >> Condor.$JobName
echo "Executable = " $Exe   >> Condor.$JobName
#echo "Arguments  = " "$@"  >> Condor.$JobName
echo "Arguments  = " "$Job.runline"  >> Condor.$JobName
echo "Initialdir = " $Dir   >> Condor.$JobName
echo "Output     = " $Job.log >> Condor.$JobName
echo "Error      = " $Job.err >> Condor.$JobName
echo "Log        = " $Job.clog >> Condor.$JobName
echo "Universe   = vanilla" >> Condor.$JobName
echo "notification = never" >> Condor.$JobName
echo "Getenv     = True"    >> Condor.$JobName
echo "Rank       = KFLOPS + Memory"    >> Condor.$JobName
echo 'Requirements =  Memory > 1000' >> Condor.$JobName
echo "SUSPEND    = False"    >> Condor.$JobName

echo ""                     >> Condor.$JobName
echo "Queue"                >> Condor.$JobName

cat Condor.$JobName

condor_submit $CondorParams Condor.$JobName

