#!/bin/bash
#Authors: zollmann, ashishv initially from vogel
#Example Usage: condorsubmit-stderr.sh 1 parselog parseIt.sh toparse
#Output: toparse.log/err
#toparse.err includes start time, machine

#Uses the Job as an identifier and runs the Exe with arguments
#the Job.clog is the condor log file that we need to wait for in order to wait for this process to finish
#while Job.log is the actual log file
maxdays="$1"
Job="$2"
JobName=`echo $Job | replace "\/" "-"`
echo "JobName $JobName"
#set CondorParams = "$2" # can be ''
CondorParams=""

#Runs the line under runexp which adds jobs start time, where its running
#to the error stream
Exe=`which runexp-stderr.sh`

shift
shift
#shift

# Original rack machine list
# Machine="islr0s0 islr0s1 islr0s2 islr0s3 islr0s4 islr0s5 islr0s6 islr0s7 islr0s8 islpc9"
# Condor with pre-emptions : r0s3, r0s4

# All non evict machines
#m="islr0s1 islr0s2 islr0s5 islr0s6 islr0s7 islr0s8"
m="islr0s2 islr0s6 islr0s8"
Machineline=`echo $m|perl -pe 's/ /.is.cs.cmu.edu\" \|\| Machine == \"/g , s/^/\( Machine == \"/g , s/\n/.is.cs.cmu.edu\" \)/g ;'`

echo $Machineline

Dir=`pwd`
#echo "in      " $Dir
unset DISPLAY

echo "########################################"  > Condor.$JobName
echo "# Job: Condor."$Job     >> Condor.$JobName
echo "# Submitted on:" `date` >> Condor.$JobName
echo "# In directory:" `pwd`  >> Condor.$JobName
echo "########################################" >> Condor.$JobName
echo ""                     >> Condor.$JobName
echo "+SMTJob = True" >> Condor.$JobName
echo "Executable = " $Exe   >> Condor.$JobName
echo "Arguments  = " "$@"  >> Condor.$JobName
echo "Initialdir = " $Dir   >> Condor.$JobName
echo "Output     = " $Job.log >> Condor.$JobName
echo "Error      = " $Job.err >> Condor.$JobName
echo "Log        = " $Job.clog >> Condor.$JobName
echo "Universe   = vanilla" >> Condor.$JobName
echo "notification = never" >> Condor.$JobName
echo "Getenv     = True"    >> Condor.$JobName
echo "Rank       = KFLOPS + Memory"    >> Condor.$JobName
#echo 'Requirements = Arch == "x86_64" && Memory > 0 ' >> Condor.$JobName
echo "Requirements = $Machineline && (SMTServer == True)" >> Condor.$JobName
echo "SUSPEND    = False"    >> Condor.$JobName


echo ""                     >> Condor.$JobName
echo "Queue"                >> Condor.$JobName

cat Condor.$JobName

condor_submit $CondorParams Condor.$JobName

