#!/usr/bin/env perl

use strict;
use warnings;
use Getopt::Long;

#my $Lowercasing = 0;
#my $TruecasingData = '';



#die if !GetOptions('Lowercasing!' => \$Lowercasing, 'TruecasingData=s' => \$TruecasingData);

# die "No text file with truecasing data specified (option --TruecasingData)" if (!$Lowercasing && !$TruecasingData);

my @parses = ();

while (<>) {
  if ( /coolpunct_newline/ ) {
    # we've arrived at the original end-of-line
    # concatenate all sentences of this line together
    print '(S1 ' . join(' ',@parses) . ")\n";
    @parses = ();
  } else {
    chomp; # get rid of the newline symbol
 
    s/^ *\( *[^ ]* //; # remove leading '(ROOT '
    s/ *\) *$//; # remove trailing ')'

    # in the following substitution we capture three groups
    # Example parse: (SQ (MD would) (NP (PRP you)) (VP (VB like) (NP (NN ham))) (. ?))
    # $1 captures '(SQ '
    # $2 captures '(MD would) (NP (PRP you)) (VP (VB like) (NP (NN ham)))'
    # $3 captures '(. ?)'
    # we rearrange these three groups such that the punctuation mark is the first leave of the tree
    s/^ *(\( *[^ ]* )(.*) (\(\.[^\)]*\))/$1$3 $2/; # shift punctuation leaf '(. .)' or '(. ?)' or '(. !)'
    # now save the result in @parses
    push @parses, $_;

    #  my @tokens = split(' ',$_);
    #  my $sentence_start = 0;
    #  print STDERR "Error in coolpunct-parsing-pre line $. '$_': line doesn't start with punctuation mark\n" if $tokens[0] !=~ /^(\.|\!|\?)$/ ;

  }
}
