#!/usr/bin/env perl

use strict; 
use BerkeleyDB; 
use Getopt::Long;

my $Duplicates = 1;

die if !GetOptions('Duplicates!' => \$Duplicates);

my $sentencenumber = 0;

for (my $i=0; $i<scalar(@ARGV); $i++) {

my $filename = $ARGV[$i] ; 
print STDERR "Processing DB $filename\n";
#unlink $filename ; 
my $db = new BerkeleyDB::Btree -Filename => $filename, -Cachesize => 500*2**20, -Flags => DB_RDONLY, -Property => ($Duplicates? DB_DUP : 0) 
  or die "Cannot open file $filename: $! $BerkeleyDB::Error\n" ; 
# Add a few key/value pairs to the file 
#$db->db_put("red", "apple") ; $db->db_put("orange", "orange") ; $db->db_put("green", "banana") ; $db->db_put("yellow", "banana") ; $db->db_put("red", "tomato") ; $db->db_put("green", "apple") ; 

# print the contents of the file 
my ($k, $v) = ("", "") ; 
my $cursor = $db->db_cursor() ; 
while ($cursor->c_get($k, $v, DB_NEXT) == 0)
 {
    $sentencenumber++;
    #print STDERR "Processing rule number $sentencenumber...\r" if $sentencenumber % 10000 == 0;


   #remove possible null-termination characters
   $k =~ s/\0$//;
   $v =~ s/\0$//;
   
   print "$k\#$v\n" 
 } 
undef $cursor ;
undef $db ;

}


