#!/bin/perl
#Prunes the phrase table to include only the top X translations, where X is the parameter
#given in ARGV[0]

my @sourceWords = ();
my $lastSource = "";
my $pruneTo = $ARGV[0];

my @scalingFactors = (0.42, 1.37, 1.4, 0.197, 1.0);
while (<STDIN>){
    my $oneLine = $_;
    chomp($oneLine);
    if ($oneLine =~ m/\@(.*) \# (.*) \# (.*) \# (.*)/){
	#print "Source: $2 \n";
	my $newSourceWord = $2;
	if ($lastSource eq $newSourceWord){
	    #print "Equal\n";
	    push @sourceWords,  $oneLine;
	}else{
	    #print "NotEqual\n";
	    my @newlist = ();
	    #print out/pare down the last one
	    my %probLine = ();
	    foreach my $entry (@sourceWords){

		if ($entry =~ m/\@(.*)\# (.*) \# (.*) \# (.*)/){
		    my @modelScores =  split(/ /, $4);
		    my $sum = 0;
		    for (my $m =0; $m<scalar(@modelScores); $m++){
			$sum = $sum +$scalingFactors[$m]*$modelScores[$m];
		    }
		    $probLine{$entry} = $sum;
		    #print "lastSource: $lastSource $sum $entry\n";
		}

	    }
	    my @sortedKeys = reverse sort { $probLine{$a} cmp $probLine{$b} } keys %probLine;
	    my $numChosen = 0;

	    #print "NumSorted: ", scalar(@sortedKeys), "\n";
	    my $pruneSize = $pruneTo;
	    if (scalar(@sortedKeys)<$pruneTo){
		$pruneSize = scalar(@sortedKeys);
	    }
	    for (my $e = 0; $e<$pruneSize; $e++){
		print $sortedKeys[$e], "\n";
	    }
	    
	    @sourceWords  = ();
	    #print "NewWord: ", $newSourceWord, "\n";
	    push @sourceWords, $oneLine;
	}
	$lastSource = $2;

    }
    

}
