#!/bin/tcsh -f 
#Build models from the source provided and run TranslateTS

set SOURCE_TM = $1
echo 'SOURCE_TM' $SOURCE_TM | stdin2stderr
set TARGET_TM = $2
echo 'TARGET_TM' $TARGET_TM | stdin2stderr
set DoBuildModels = $3
echo "DoBuildModels=$DoBuildModels"
set PhraseAlignBeamSize = $4
set MaxPhraseLength = $5
shift
set DoGenerateParamFile=$5
shift
set StartSentence = $5
shift
set StopSentence = $5
echo "`date`. Running ersub_translate.sh. MaxPhraseLength=$MaxPhraseLength, PhraseAlignBeamSize=$PhraseAlignBeamSize" | stdin2stderr
#TARGET_LM should be completely irrelevant. But it needs to exist for some stupid reason :)
#set TARGET_LM = $2
#set TARGET_LM = /nfs/islpc7_1/Andreas/andi2/newnewexp/training-bi.english
#now we are actually creating a LM as well
set TARGET_LM = $TARGET_TM
echo 'TARGET_LM' $TARGET_LM | stdin2stderr

#set LOGFILE = $3
#echo 'TranslateTS logfile' $LOGFILE | stdin2stderr
#TranslateTS logfile now goes to STDOUT

set STAGING_DIR = .
echo 'STAGING_DIR' ${STAGING_DIR} | stdin2stderr


#runtime options


#set DoBuildTM = 1

#set DoGenPhrases = 1



#setenv LC_ALL UTF8

    
set VOC = ${STAGING_DIR}/All.voc

if ($DoBuildModels) then

    # rm -rf ${STAGING_DIR}
    # mkdir ${STAGING_DIR}

    echo "ersub_translate.sh: `date`. Building voc All.voc" | stdin2stderr
    #cat ${SOURCE_TM} ${TARGET_TM} ${TARGET_LM} ${SOURCE_TEST} ${TARGET_TEST} | ~vogel/bin/Tools/MakeVoc > ${STAGING_DIR}/All.voc
    cat ${SOURCE_TM} ${TARGET_TM} ${TARGET_LM} | MakeVoc > ${STAGING_DIR}/All.voc


    echo "ersub_translate.sh: `date`. Building LM with training target direction: perl -S CreateSplitLM.pl ${TARGET_LM} ${TARGET_LM}.srilm" | stdin2stderr
    perl -S CreateSplitLM.pl ${TARGET_LM} ${TARGET_LM}.srilm|stdin2stderr
    
    #if ($DoBuildTM) then
	echo "Building TMs: perl -S CreateSplitTM.pl ${SOURCE_TM} ${TARGET_TM} ${VOC} ${SOURCE_TM}.T"|stdin2stderr
	perl -S CreateSplitTM.pl ${SOURCE_TM} ${TARGET_TM} ${VOC} ${SOURCE_TM}.T|stdin2stderr
	
	grep '^10'  ${SOURCE_TM}.T | stdin2stderr
	grep '^10'  ${SOURCE_TM}.T.rev | stdin2stderr
    #endif
    
    echo "`date`. Building SA with $SOURCE_TM" | stdin2stderr
#    ~joy/Release/SuffixArray/IndexSA ${SOURCE_TM}|stdin2stderr
    IndexSA ${SOURCE_TM}|stdin2stderr

endif	
    
    
  set MERPARAMS =  "${STAGING_DIR}/mer.param"
    set MERFORWARD = "${STAGING_DIR}/mer-arabicToEnglish.param"
    set MERREVERSE = "${STAGING_DIR}/mer-englishToArabic.param"
#generate the params file and run the mer
if ($DoGenerateParamFile) then

    echo "ersub_translate.sh: `date`. Building parameter files" | stdin2stderr
    
    rm -f ${MERPARAMS}

    rm -f ${MERFORWARD}
    rm -f ${MERREVERSE}
    
    #basic parameters
    echo "SplitCharacters #" >> $MERPARAMS
    echo "LM SriLM " >> ${MERPARAMS}
    echo "TraceLevel 0.0 " >> ${MERPARAMS}
    echo "DisplayLatticeStatistics 0 " >> ${MERPARAMS}
    echo "DisplayNBestData 0 " >> ${MERPARAMS}
    
    #ordering parameters
    set TMLIST = "0.184797_2.90077_0.047687_1.32328_0.108385_0.202534"
    echo 'TMScaleList' $TMLIST >> ${MERPARAMS}
    echo "LMScale 2.2" >> ${MERPARAMS}
    echo "ALScale 0.0" >> ${MERPARAMS}
    echo "SLScale -2.6" >> ${MERPARAMS} 
    echo "PLScale 0.25" >> ${MERPARAMS}

    echo "NormalizingScript ~zollmann/projects/coolsmt/DoNothing.pl " >> ${MERPARAMS}

#    echo "PhraseAlignBeamSize                 0.000000001" >> ${MERPARAMS}
#    echo "PhraseAlignBeamSize                 3.0" >> ${MERPARAMS}
    echo "PhraseAlignBeamSize                 $PhraseAlignBeamSize" >> ${MERPARAMS}
    echo "PhraseAlignMaxTranslations           100" >> ${MERPARAMS}
    echo "PhraseAlignScaleList                2.0_2.0_0.5_0.5_0.1_0.1" >> ${MERPARAMS}
    
    #search parameters
    echo "CompareHypFeatures 7.0 " >> ${MERPARAMS}
    echo "PruneHypFeatures 1.0 " >> ${MERPARAMS}
    echo "LengthOfReorderingWindow 1 " >> ${MERPARAMS}
    echo "ReorderingsPerWord 0.0 " >> ${MERPARAMS}
    echo "BeamSize 20.0 " >> ${MERPARAMS}

    
    #mer parameters
    echo "MEROptimize 1 " >> ${MERPARAMS}
    echo "NBest 1000.0 " >> ${MERPARAMS}
    echo "IterationLimit 5 " >> ${MERPARAMS}
    echo "ParameterRestrictionFile ${STAGING_DIR}/AllOpen-6Scores.opt " >> ${MERPARAMS}
    #create the all open 6 param file
    rm -f ${STAGING_DIR}/AllOpen-6Scores.opt
    echo "0 0 -6 -6 0 0 0 0 0 0" >> ${STAGING_DIR}/AllOpen-6Scores.opt
    echo "6 0.001  3  3  3 3 3 3 3 3" >> ${STAGING_DIR}/AllOpen-6Scores.opt
    ##cp ${STAGING_DIR}/AllOpen-6Scores.opt .
    
    echo "Vocabulary $VOC " >> ${MERPARAMS}
#    echo "SentenceList $SOURCE_TEST" >> ${MERPARAMS}
    echo "SentenceList $SOURCE_TM" >> ${MERPARAMS}
    echo "WordLM $TARGET_LM.srilm" >> ${MERPARAMS}


    #copy over the base stuff
    cp ${MERPARAMS} ${MERFORWARD}

    #pesa parameters
    echo "LambdaLexicon 0.5 " >> ${MERFORWARD}
    echo "SA_HighestFrequency 10000000.0 " >> ${MERFORWARD}
    echo "SA_MaxOccurence    10.0 " >> ${MERFORWARD}
#    echo "SA_ShortesPhraseLength 1.0 " >> ${MERFORWARD}
    echo "SA_ShortestPhraseLength 1.0 " >> ${MERFORWARD}
    echo "SourceFileSA $SOURCE_TM" >> ${MERFORWARD}
    echo "SourceFile $SOURCE_TM" >> ${MERFORWARD}
    echo "TargetFile $TARGET_TM" >> ${MERFORWARD}
    
    echo "Lexicon $SOURCE_TM.T" >> ${MERFORWARD}
    echo "ReverseLexicon $SOURCE_TM.T.rev" >> ${MERFORWARD}


    #echo "ReferenceList $TARGET_TEST" >> ${MERFORWARD}
    
endif #DoGenerateParamFile


if ($StartSentence) then
    head -$StopSentence $SOURCE_TM | tail +$StartSentence > $SOURCE_TM.$StartSentence
    set StartSentenceLine="--StartSentence=$StartSentence"
    set StopSentenceLine="--StopSentence=$StopSentence"
    set SentenceList=$SOURCE_TM.$StartSentence
else
    set StopSentenceLine=
    set StartSentenceLine=
    set SentenceList=$SOURCE_TM
endif

#if ($DoGenPhrases) then
    #use translate phrase here, since we just want the complete phrase,not the sub phrases
    #    /nfs/progress2/src/STTK2K4/src/TranslateTS -f ${MERFORWARD} --SentenceList=$SOURCE_TM  --DisplayLatticeStatistics=1 --BeamSize=1 --MEROptimize=0 --NBest=1 > TranslateTS.log
    echo "ersub_translate.sh: `date`> CurrentSentenceTranslateTS -f ${MERFORWARD} --SentenceList=$SentenceList --DisplayLatticeStatistics=1 --BeamSize=1 --MEROptimize=0 --NBest=1 --MaxPhraseLength=$MaxPhraseLength $StartSentenceLine $StopSentenceLine" | stdin2stderr
    CurrentSentenceTranslateTS -f ${MERFORWARD} --SentenceList=$SentenceList --DisplayLatticeStatistics=1 --BeamSize=1 --MEROptimize=0 --NBest=1 --MaxPhraseLength=$MaxPhraseLength $StartSentenceLine $StopSentenceLine
#endif

if ($StartSentence) then
    rm $SOURCE_TM.$StartSentence
endif
