#!/usr/bin/env perl

use warnings;
use strict;

my $sentencenumber = -1;
while (<>) {
  if (/^\=+Sentence ([^ ]*) /) {
    $sentencenumber++;
    die "$sentencenumber different from $1" if $sentencenumber ne $1;
  } elsif (/raw: (.*) UNKNOWN-TAGGED-handled translation: (.*[^ ]) +PARSE:/) {
    # convert neglog probs into log probs
    my @costs = split(' ',$1);
    foreach my $x (@costs) {
      $x *= -1;
    }
    print $sentencenumber . ' ||| ' . $2 . ' ||| ' . join(' ',@costs) . "\n";
  }
}

print STDERR "Processed " . ($sentencenumber+1) . " sentences\n";

