#!/usr/bin/env perl
#
# This program is used to extract text from the SGML file
#
# originally by Joy, joy@cs.cmu.edu
# May 11, 2004
#
# Usage:
#	extractRefFromSgml.pl < sgml_text > STTK_style_refs
#
# 
use warnings;



%references=();
@ref_ids = ();

while(<STDIN>){
	if((/^<DOC/) || (/^<doc/)){
	    if(/\s+docid=.+sysid=\"(.+)\">/){
		$currentRefId=$1;
		  if(! defined $references{$currentRefId}){
		    push @ref_ids,$currentRefId;
		    $references{$currentRefId} = [];
		}
	    }
	}
	if(/<seg id=[^>]+>\x20*([^\<\>]+)\x20*<\/seg>/){
		push @{$references{$currentRefId}}, $1;
	}
}

my $number_sentences = -1;
  foreach my $x (@ref_ids) {
#    my $tmp = () = $references{$x} =~ /\n/g;
    my $tmp = scalar(@{$references{$x}});
    die "Inconsistent number of sentences per reference" if $number_sentences != -1 && $number_sentences != $tmp;
    $number_sentences=$tmp;
  }
for (my $i=0;$i<$number_sentences;$i++) {
  foreach my $x (@ref_ids) {
      my $r = $references{$x}->[$i];
      $r =~ s/\s+/ /g;
      $r =~ s/\s+$//g;
      $r =~ s/^\s+//g;
    print  $r. "\n";
  }
}
print STDERR "File contains references for $number_sentences test sentences. " . scalar(@ref_ids) . " references per test sentence.\n";

#$index=1;
#foreach $systemId(keys %references){
#	open outputFile,">ref.$index";
#	$line = $references{$systemId};
#	$line=~s/^\x20+//;
#	print outputFile $line;
#	close outputFile;
#	$index++;
#}
