#!/bin/tcsh -f
#####!/bin/csh -f

#set your path appropriately, so that replace,extractrules.pl,CreateSplit_TM.pl,CreateSplit_LM.pl,ersub_translate.sh can be found
#set path = (~zollmann/projects/coolsmt $path)

#all files created are created in the current working directory

set source=$1
set target=$2
set translatetslog=$3 # if different to '-', write out log file for CurrentSentenceTranslateTS
if ("$translatetslog" == "-") then
    set translatetslog=
endif
set PhraseAlignBeamSize = $4
shift
set MaxLengthSP = $4 # max length of source phrases extracted by CurrentSentenceTranslateTS
set MaxLengthSCSP = $5 # max length of source phrases of rules that occur only once
set MAXSOURCEWORDCOUNT = $6; # max n.o. source words in created rules
set MAXTARGETWORDCOUNT = $7; # same for target
set MAXSOURCESYMBOLCOUNT = $8; # max n.o. source symbols (source words + substitutions) in created rules
set MAXTARGETSYMBOLCOUNT = $9; # same for target
shift
set MAXSUBSTITUTIONCOUNT = $9; # max n.o. substitutions allowed in created rules
shift
set StartSentence = $9;
if ("$StartSentence" == "-") then
    set StartSentence=0
    set StartSentenceLine=
    set DoGenerateParamFile=1
else
    set StartSentenceLine="--StartSentence=$StartSentence"
    set DoGenerateParamFile=0
endif
shift
set StopSentence = $9;
if ("$StopSentence" == "-") then
    set StopSentence=0
    set StopSentenceLine=
else
    set StopSentenceLine="--StopSentence=$StopSentence"
endif
shift
set extractrulesparams = "$9";

set DoParsing=1
set DoBuildModels=0

date | stdin2stderr

if ($DoParsing) then

# first parse all target sentences (-T210 is default speed, -T50 is supposed to lose one percent of accuracy; -l400 allows for sentence length up to 400 words (that's the maximum) )
# T5 takes 4 hours on europarl
echo "cat $target | replace '^(.*)\n' '<s> \1 <\/s>\n' | /nfs/islpc7_1/Andreas/programs/parser05Aug16/PARSE/parseIt -T20 -l400 -N1 /nfs/islpc7_1/Andreas/programs/parser05Aug16/DATA/EN/ | replace '^\n' '' >targetparsetrees" |stdin2stderr
cat $target | replace '^(.*)\n' '<s> \1 <\/s>\n' | /nfs/islpc7_1/Andreas/programs/parser05Aug16/PARSE/parseIt -T20 -l400 -N1 /nfs/islpc7_1/Andreas/programs/parser05Aug16/DATA/EN/ | replace '^\n' '' >targetparsetrees

date | stdin2stderr

endif


# to match words of target sentences to words of charniak's parses, we have to change e.g. "it's" to "it 's",
# making two words out of one for the translation process
# (this could easily be undone for testing)
#az 06/02/13: this is now done for all data in sbmtpreprocess.sh
#replace "\b'" " '" <$target >$target.preprocessed

        
# now call TranslateTS variant and extractrules.pl
#!!ersub_translate.sh $source $target $DoBuildModels $PhraseAlignBeamSize $MaxLengthSP $DoGenerateParamFile $StartSentence $StopSentence | tee $translatetslog | \
#!!   perl -w -S extractrules.pl $source $target targetparsetrees - $MAXSOURCEWORDCOUNT $MAXTARGETWORDCOUNT $MAXSOURCESYMBOLCOUNT $MAXTARGETSYMBOLCOUNT $MAXSUBSTITUTIONCOUNT --MaxLengthSingleCountSourcePhrases=$MaxLengthSCSP $StartSentenceLine $StopSentenceLine --outputdbfile=extractedrules$StartSentence $extractrulesparams

