#!/usr/bin/env perl
#Takes as input a pipe that looks like and output a file with ONLY the numtag matching phrases / sentences
# paste -d"#" srcFile tgtFile | filter-bad-phrases.pl > both.file
# cat both.file | awk -F"#" '{print $1}' > src.side
# cat both.file | awk -F"#" '{print $2}' > tgt.side

use strict;
use warnings;

my $stat_zeros = 0;
my $stat_reject = 0;
my $stat_matched = 0;

use Getopt::Long;
my $truecount = 1;
die if !GetOptions('truecount!' => \$truecount);

print STDERR "Using truecount $truecount\n";

while (<>){
    my $line = $_;
    chomp($line);
    my @parts = split(/( *\# *| *\|\|\| *)/, $line);
    my $src = $parts[0];
    my $tgt = $parts[2];
    
    my $src_count=0;
    $src_count++ while $src =~ /numtag/g;

    my $tgt_count=0;
    $tgt_count++ while $tgt =~ /numtag/g;

    if ($truecount==0){
	if ($tgt_count>0){$tgt_count=1;}
	if ($src_count>0){$src_count=1;}
    }

    if ($src_count != $tgt_count){
	#print "REJECT SRC $src NUM: ", scalar(@numMatchesSrc), " TGT $tgt NUM: ", scalar(@numMatchesTgt), "\n";
	$stat_reject++;
    }else{
      print $line, "\n";
      if ($src_count>0){
	$stat_matched++;
      }else{
	#print "ZERO SRC $src NUM: ", scalar(@numMatchesSrc), " TGT $tgt NUM: ", scalar(@numMatchesTgt), "\n";
	$stat_zeros++;
      }

    }
}

print STDERR "Rejected $stat_reject Zeros $stat_zeros Matched $stat_matched\n";
