#!/usr/bin/env perl

use strict; 
use warnings;
#use BerkeleyDB; 
use Getopt::Long;

my $SortFeatureOffset = 6;
my $MaxPhraseLength=20;

die if !GetOptions('SortFeatureOffset!' => \$SortFeatureOffset);

my %rules = ();
my $sentencenumber = 0;

my $filename = $ARGV[0] ; 
print STDERR "Processing DB text file $filename\n";
open(DBFILE, "< $filename");
while (<DBFILE>) {
  $sentencenumber++;
  print STDERR "Processing rule number $sentencenumber...\n" if $sentencenumber % 100000 == 0;

  chomp;
  my @rule = split(/ *\# */, $_);
  my $translations = exists($rules{$rule[0]})? 
    ($rules{$rule[0]} . "\n") : 
     '';
  $translations .= join('#',@rule[1..$#rule]);
  $rules{$rule[0]} = $translations;
} 

print STDERR "Processing sentences from STDIN\n";
$sentencenumber = 0;
while (<STDIN>) {
  $sentencenumber++;
  print "\nSentence $sentencenumber: ";
  print $_;
  chomp;
  my @sentence = split;
  for (my $i = 1; $i < $MaxPhraseLength; $i++) {
    my $printprefix = "Matches of length $i:\n";
    for (my $j = 0; $j+$i <= scalar(@sentence); $j++) {
      my $key = join(' ',@sentence[$j..$j+$i-1]);
      my $value = $rules{$key};
      if (defined($value)) {
	print $printprefix;
	$printprefix = '';
	my @translations = split("\n", $value);
	for (my $k = 0; $k < scalar(@translations); $k++) {
	  print( ($k==0? "$key -> " : (" " x length("$key -> "))) . $translations[$k] . "\n");
	}
      } else {
	print "Unknown word in sentence $sentencenumber: $sentence[$j]\n" if $i==1;
      }
    }
  }
}


