#!/usr/bin/env perl
#Joins a sequence of files together with a separator, allows you to use sequences to join instead of
#just a single character! If the files are of different lengths then the one with miniumum length is used
use IO::File;
use strict;
use Getopt::Long;

my $sep = "#";
my @files = ();
die if !GetOptions("sep=s" => \$sep, "files=s", \@files);

my @fds = ();
foreach my $filename (@files){
    my $fd =  new  IO::File("$filename", "r") or die "Unable to open file $filename\n";
    print STDERR "Opening $filename\n";
    push (@fds, $fd);
}

while (1){
    my $hasMore = 1;
    my @arr = map {my $l = <$_>; if (defined($l)){chomp($l); $l; }else{ $hasMore=0; undef; }}@fds;
    if ($hasMore==1){
	my $line = join("$sep", @arr);
	print $line, "\n";
    }else{
	last;
    }
}



