#!/bin/tcsh -f
#The full segmentation, pre-processing and training for BTEC

# SRC = /project/IWSLT/IWSLT-2006/fullBTEC/chn/fullBTEC.gb
# TGT =  /project/IWSLT/IWSLT-2006/fullBTEC/usa/fullBTEC.en
set TGT = `expandfilename $1`

#######################################################
# preprocessing including number handling
# this is based on Ashish's IWSLT script directory:
#pushd /nfs/islpc7_2/ashishv/iwslt/data/scripts/

#use this to produce numtag LM having @CD wherever there was a number
#produces: $TGT.ibm.num.pp
#./FinalTgtTokenizeAndTag.sh $TGT 1 # 1 says: move punct. marks
#./FinalTgtTokenizeAndTag.sh $TGT # don't move punct. marks
#cat $TGT.ibm.num.pp | ./PrepareTraining.sh > $TGT.final

#use this to produce an LM based on the actual numbers
#produces: $TGT.ibm.pp
#echo "./FinalTgtTokenizeOnly.sh $TGT 1" # 1 says: move punct. marks
#echo "cat $TGT.ibm.pp  | ./PrepareTraining.sh > $TGT.final"


#popd

set SCRIPTS = /nfs/islpc7_2/ashishv/iwslt/data/scripts/
#setenv PATH ~zollmann/projects/coolsmt/:$PATH
#pushd /data/isltmp3/GaleEval2006/nbach/IWSLT2006/EN-Tokenizer/
pushd /nfs/islpc7_2/ashishv/iwslt/data/scripts/tagging/EN-Tokenizer >& /dev/null

# then the same with number tags
cat $TGT \
# | $SCRIPTS/replace '^[^\\]*\\[^\\]*\\(.*)\\.*\n' '$1\n' \
# | $SCRIPTS/replace '\|' ' ' \
| perl ./eng_tokenizer.pl \
| perl ./eng_simpl_class.pl keep_cont class_spell_out_num | replace '^ +| +$' '' \
| ReplaceAllNumTags.pl | replace ' # \n' '\n' | sbmtpreprocess.pl > $TGT.ibm.num

popd >& /dev/null


##############################################
# back in the current directory

# 
punctuation-preprocess.pl < $TGT.ibm.num --TruecasingData $TGT.ibm.num \
| sed -n 's/numtag/@CD/g; p' > $TGT.withCDtags


#build the LM - with the numtag replaced with @CD so that the decoder can use this symbol
cat $TGT.withCDtags \
|  /nfs/islpc7_2/ashishv/external-tools/sri/bin/i686-m64/ngram-count \
  -text - -lm $TGT.4gram-restr.srilm -kndiscount -order 4\
-vocab /data/SMT2/TC_STAR/expsamt/sorted.allextract.v0.filtdb.tcstar.pr0.03.minnon40.minlex10.db.targets.1wordperline
# try also:
# -interpolate
# -vocab vocab-restriction-file

