#!/usr/bin/env perl

use strict;
use warnings;

my %vocab = ();

while (<>) {
  chomp;
  s/\#/ /g;
  my @sentence = ('<s>', split(' ',$_), '</s>');
  for (my $i=0; $i < scalar(@sentence); $i++) {
    ++$vocab{$sentence[$i]};
  }
}

# sort vocab descendingly by frequency
my @sorted_vocab = sort { $vocab{$b} <=> $vocab{$a} } keys %vocab;

foreach my $x (@sorted_vocab) {
  print $x . "\n";
}

