#!/usr/bin/env perl
#Does merging of feats and cands files for MER
#Takes files from the newly created $latestdir and merges them the feats and cands in the mergedir
#and then cats them all together to form the .opt files. If $mergedir eq $latestdir the only task
#of this tool is to create the .opt files
use strict;

#merged files - tagged with expdir/iter 
my $mergeddir = $ARGV[0];

#directory for latest files like expdir/iter0
my $latestdir = $ARGV[1];

my $sortline = " LC_ALL=C; export LC_ALL; sort -T . ";

my @mergedfeats = ();
my @mergedcands = ();
#initialize a merged directory only if it exists
if (-e $mergeddir){
    @mergedfeats = glob("$mergeddir/*.feats");
    @mergedcands = glob("$mergeddir/*.cands");
}else{
    print STDERR "No merge directory found $mergeddir\n";
    exit;
}


my @latestfeats = glob("$latestdir/*.feats");
my @latestcands = glob("$latestdir/*.cands");

#go thru all the latest ones, cause you know they are there
my $numbefore = 0;
print STDERR "Num Sentences: ", scalar(@latestcands), "\n";

if ($mergeddir eq $latestdir){

}else{
    for (my $s=0; $s<scalar(@latestcands); $s++){
	my $latest_f = $latestfeats[$s];
	my %uniquelements = ();    
	print STDERR "Merging sentence: $s\n";
	#fill with the new ones
	#addtouniq($latest_f, \%uniquelements);
	print `$sortline -u $latest_f -o $latest_f`;
	#fill with the existing ones
	if (scalar(@mergedfeats)!=0){
	#print STDERR "In merge\n";
	    #addtouniq($mergedfeats[$s], \%uniquelements);
	    $numbefore += `wc -l $mergedfeats[$s] `;
	    my $runme = "$sortline -u --merge $mergedfeats[$s] $latest_f -o $mergedfeats[$s]";
	    print `$runme`;
	}else{
	#make the foundation of the merge
	    #print "cp $latest_f $mergeddir/\n";
	    print STDERR "In copy\n";
	    `cp $latest_f $mergeddir/`;
	    #$numbefore += `wc -l $latest_f `;
	}
    }
}
my $numnow = printoptifiles($mergeddir, scalar(@latestcands));
my $numnew = $numnow-$numbefore;
print "$numnew\n";

sub printoptifiles{
    my ($out_dir, $numsent) = @_;
    #loop thru the files, put them all in one big file

    my $runlineFeats = "cat ";

    print STDERR "Building opti files: $out_dir/feats.opt and $out_dir/cands.opt\n";
    open CANDS, "> $out_dir/cands.opt" or die "Unable to open $out_dir/cands.opt";
    my $outFeats = "$out_dir/feats.opt"; #output file that we are creating
    for (my $s=0; $s<$numsent; $s++){
	#$runlineFeats = $runlineFeats." $out_dir/$s.feats";	
	my $num = `wc -l $out_dir/$s.feats`;
	chomp($num);
	$num =~ s/^([0-9]+).*/$1/g;
	print CANDS "$s ", $num, "\n";
	$numnow += $num;
	#build up the feats file
	my $catted = ($s==0) ? ` cat $out_dir/$s.feats > $outFeats` : `cat $out_dir/$s.feats >> $outFeats` 
    }
    close(CANDS);
    return $numnow;
}

#write a set of unique files into a directory
sub printtodir{
    my ($dir, $unique_ref, $sno) = @_;
    my $ff = "$dir/$sno.feats";
    
    open FEATS, "> $ff" or die "Unable to write to file $ff\n";
    foreach my $key (keys %$unique_ref){
	print FEATS "$key\n";
    }
    close(FEATS);

    my $cf = "$dir/$sno.cands";
    open CANDS, "> $cf"  or die "Unable to write to cands file $cf\n";
    print CANDS "$sno ", scalar(keys %$unique_ref), "\n";
    
}

sub addtouniq{
    my ($file, $unique_ref) = @_;
    open FILE, "$file" or die "Unable to open file $file\n";
    #print "Opening in addtouniq: $file\n";
    while (<FILE>){
	my $line = $_;
	chomp($line);
	#print "Feats in addtouniq: $line\n";
	if (!exists($unique_ref->{$line})){
	    $unique_ref->{$line} = 1;
	}
    }
}


