#!/usr/bin/env perl
#!/nfs/islpc7_1/Andreas/ActivePerl-5.8/bin/perl

#use strict;
use warnings;
use Getopt::Long;

my $lowercase;
die if !GetOptions("lowercase!" => \$lowercase);


#fire up output buffering
$|=1;
while (<>) {
  chomp;			# get rid of the newline symbol (will otherwise disturb us when removing multiple whitespace below)
  s/^\s+//g;			# handle possible \r after \n

  my $line = NormalizeText_NIST($_);
  print "$line\n";		# print out the modified line, followed by a newline symbol

}



#################################
 

sub NormalizeText_NIST{

  my ($norm_text) = @_;
 
  # language-independent part:
  $norm_text =~ s/<skipped>//g; # strip "skipped" tags
  $norm_text =~ s/-\n//g;	# strip end-of-line hyphenation and join lines
  $norm_text =~ s/\n/ /g;	# join lines
  $norm_text =~ s/(\d)\s+(?=\d)/$1/g; #join digits
  $norm_text =~ s/&quot;/"/g;  # convert SGML tag for quote to "
    $norm_text =~ s/&amp;/&/g;	# convert SGML tag for ampersand to &
  $norm_text =~ s/&lt;/</g;	# convert SGML tag for less-than to >
  $norm_text =~ s/&gt;/>/g;	# convert SGML tag for greater-than to <
 
  # language-dependent part (assuming Western languages):
  $norm_text = " $norm_text ";
  $norm_text =~ tr/[A-Z]/[a-z]/ if $lowercase;
  $norm_text =~ s/([\{-\~\[-\` -\&\(-\+\:-\@\/])/ $1 /g; # tokenize punctuation
  $norm_text =~ s/([^0-9])([\.,])/$1 $2 /g; # tokenize period and comma unless preceded by a digit
  $norm_text =~ s/([\.,])([^0-9])/ $1 $2/g; # tokenize period and comma unless followed by a digit
  $norm_text =~ s/([0-9])(-)/$1 $2 /g; # tokenize dash when preceded by a digit
  $norm_text =~ s/\s+/ /g;	# one space only between words
  $norm_text =~ s/^\s+//;	# no leading space
  $norm_text =~ s/\s+$//;	# no trailing space
 
  return $norm_text;
}
 
#################################



