#!/bin/csh -f
#Extraction script that handles an atomic alignment file and parse file and runs extraction - optionally just run extraction
set ALTFILE = $1
set PARSEFILE = $2
set OUTDIR = $3
set DEVANDTEST = $4 #do filterring for a particular dev and test set
set LEX = $5 #lexical weight file, required for rule extraction
set LEXREV = $6 #lexical weight file, required for rule extraction
set FIRSTSTEP = $7 #step 1 is parse, step 2 is extraction, step 3 is extraction"


set PARSEFILEBASE = `basename ${PARSEFILE}`
set ALTFILEBASE = `basename ${ALTFILE}`
echo "Running ${PARSEFILEBASE} ${ALTFILEBASE}"

if (${FIRSTSTEP} <= 1) then
#just do 1 best parsing now
#echo "PARSING: ${PARSEFILE}"
set PARSECMD = "parse-charniak-fastsimple.sh ${PARSEFILE} ${OUTDIR}"
echo "PARSE: " condorsubmit-all.sh 1 ${OUTDIR}/${PARSEFILEBASE}.cond ${PARSECMD}
condorsubmit-all.sh 1 ${OUTDIR}/${PARSEFILEBASE}.cond ${PARSECMD}
sleep 1
endif

if (${FIRSTSTEP} <= 2) then
#do per sent extraction with max len 10 and 5
set EXTRACTCMD = "extractphrases.sh ${ALTFILE} 10 5 ${OUTDIR}/hiero-${ALTFILEBASE}"
echo "EXTRACT: " condorsubmit-stderr.sh 1 ${OUTDIR}/${ALTFILEBASE}.cond ${EXTRACTCMD}
condorsubmit-stderr.sh 1 ${OUTDIR}/${ALTFILEBASE}.cond ${EXTRACTCMD}
sleep 1

endif

if (${FIRSTSTEP} <= 3) then
#make sure parsing and alignment both exist
#/usr/local/libexec/condor/bin/condor_wait ${OUTDIR}/${PARSEFILEBASE}.cond.clog 
#/usr/local/libexec/condor/bin/condor_wait ${OUTDIR}/${ALTFILEBASE}.cond.clog

#set RULESCMD = "cat ${OUTDIR}/${ALTFILEBASE}.cond.log | extractrules.pl -r ${DEVANDTEST} --TargetParseTreeFile ${OUTDIR}/${PARSEFILEBASE}.parsed"
#set the decisions that affect runtime
#set RULESOPTS = " --PhrasePairFeedFile - --MaxSourceLength 30 --MaxSourceWordCount=10 --MaxTargetWordCount=15 --noTightSubRules --MaxSourceSymbolCount=10 --MaxTargetSymbolCount=15 --MaxSubstitutionCount=2 --MaxSubstitutionCountAbstractRules=0 --CacheSize=2400 --tmpdir=/tmp --ConsolidationInterval=1000000 --PhrasePairSpanInfo --UseXIff --MaxSourceSymbolCountXRules=10 --nokeepunbalancedrules --ignoresourcepunctuation"
#set RULESLEX = "--LexicalWeightFile ${LEX} --LexicalWeightFileReversed ${LEXREV}"

#set RULESCMD1 = "condorsubmit.sh 1 ${OUTDIR}/rules-${ALTFILEBASE}.cond "
#set RULESCMD2 = "${RULESCMD} ${RULESOPTS} ${RULESLEX} | gzip > ${OUTDIR}/rules-${ALTFILEBASE}.maxas2-noabs-nounb.gz"
#echo ${RULESCMD1} \"${RULESCMD2}\" 

endif
