#!/usr/bin/env perl                                                                                                         
#Run the refiner with default settings                                                                                                 
my $max = 10;
my $final = 5;

my $EXPNAME = "phrases"; #this will create the working directory for output files
my $OUTPOSTFIX = "log"; #the calling script can look for $EXPNAME/*.$OUTPOSTFIX

my $PART = $ARGV[0]; #got the part 
my $NUMLINES = $ARGV[1]; #the expected number of sentence processed

#first check if the file already exists
if (-e "$PART.$OUTPOSTFIX"){
    my $numSentences = `fgrep "LOG: NUM" ${PART}.${OUTPOSTFIX} | wc -l`; 
    #$NUMLINES is the lines of data processed
    if ($NUMLINES/3==$numSentences){
	#remove any lingering clog files so that another process isn't waiting for it
	print `rm cond${PART}*.clog`;
	exit(1);
    }
}


my $runme = "cat ${PART} | extractor.py -L $max -l $final -o hiero${PART} > ${PART}.${OUTPOSTFIX}";
#if you have condor, then add some quotes to the runline and submit thru condor - this will allow the script to terminate
if (defined ($ENV{'CONDOR_SMALL'})){
    my $condor = "\$CONDOR_SMALL 1 cond${PART}";
    $runme  = $condor." \" ".$runme." \" ";
}
print STDERR "$runme\n";
print `$runme`;



