#!/bin/tcsh -f
#IWSLT data set, estable a baseline with alternative options, take the output of the runline and this provides
#a template for the final name of the file that you want to create, replace the number with "parts". This script
#is meant to be a general purpose RUNNER. all the specification must be done in the rulespart-* files!!!

set MAXPART = $1;
set SCRIPTNAME = $2;
set FILTNAME = $3;
set MERNAME = $4;
set FIRSTSTEP = $5;

set MERGER = "MergeRules 1 3 8 8 0" #0 says dont bother averaging the remaining vars
set TMPDIR = "/people/ashishv0/"

echo "Condor: " ${CONDOR}

#these scripts should exists otherwise we create all these files for nothing
if (! -e ${SCRIPTNAME} ) then
    echo "Extraction script not found: ${SCRIPTNAME}"
endif

if (! -e ${FILTNAME} ) then
    echo "Filter script not found: ${FILTNAME}"
endif

if (! -e ${MERNAME} ) then
    echo "MER script not found: ${MERNAME}"
endif

source /nfs/islpc7_2/ashishv//research/branches/arv-dev/tools/SBMT/dist/mt-64.sh

set NAME = `expnamefromscript.sh ${SCRIPTNAME}`
if ( 1 >= ${FIRSTSTEP} ) then
    
    
    #use an automatically generate log file name
    #foreach p (0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16)
    set p = 0
    while (${p} <= $MAXPART) 
	echo "${CONDOR} cond${NAME}.${SCRIPTNAME}.${p} ${SCRIPTNAME} ${p}"
	${CONDOR} cond${NAME}.${SCRIPTNAME}.${p} ${SCRIPTNAME} ${p}
	@ p += 1
    end
    #the filenames are available...

    #now.. wait for all the log files that this submission has generated
    echo "Sleeping now... 10 secs"
    echo "sleep 10"
    sleep 10
    echo "ls cond${NAME}.${SCRIPTNAME}.* | condorwaitforlogs.sh"
    ls cond${NAME}.${SCRIPTNAME}.* | condorwaitforlogs.sh

endif

#do some naming
#echo "set PARTPATTERN  = `cat cond${NAME}.${SCRIPTNAME}.0.log  | sed 's/\/0\./\/\*\./g'`"
set PARTPATTERN  = `tail -n 1 cond${NAME}.${SCRIPTNAME}.0.log  | sed 's/\/0\./\/\*\./g'`
#echo "set FINALEXTRACT = `cat cond${NAME}.${SCRIPTNAME}.0.log  | sed 's/\/0\./\/parts\./g'`"
#set FINALEXTRACT = `cat cond${NAME}.${SCRIPTNAME}.0.log  | sed 's/\/0\./\/parts\./g'`

echo "NAME ${NAME}"
echo "SCRIPT ${SCRIPTNAME}"
echo "EXTLINE: tail -n 1 cond${NAME}.${SCRIPTNAME}.0.log"
set FINALEXTRACT = `tail -n 1 cond${NAME}.${SCRIPTNAME}.0.log`
echo "Proto: $FINALEXTRACT"
set FINALEXTRACT = `dirname $FINALEXTRACT`

#use this directory to run mer experiments
set EXPDIR = ${FINALEXTRACT}
set FINALEXTRACT = "$FINALEXTRACT/parts.gz"
echo "Creating: ${FINALEXTRACT}"



#make a combined gzip file
if ( 2 >= ${FIRSTSTEP} ) then
    #put the gz file together (in case we want to do alternative filterings) the file nomenclature comes from the script
    echo "Submitting merge to condor"
    ${CONDOR} condmerge "ls ${PARTPATTERN} | fgrep -v 'parts.gz' |  xargs -i{} zcat {} | sortsafe.sh -T ${TMPDIR} |  ${MERGER} | gzip > ${FINALEXTRACT}"

endif

exit;

if ( 3 >= ${FIRSTSTEP} ) then
    
    #do filtering to create a rule db
    echo "condorsubmit-stderr.sh 1 ${FINALEXTRACT}.filt-${FILTNAME} ${FILTNAME} ${FINALEXTRACT}"
    condorsubmit-stderr.sh 1 ${FINALEXTRACT}.filt-${FILTNAME} ${FILTNAME} ${FINALEXTRACT}
    echo "sleep 10"
    sleep 10
    #gotta wait for this file now!
    echo "/usr/local/libexec/condor/bin/condor_wait ${FINALEXTRACT}.filt-${FILTNAME}.clog"
    /usr/local/libexec/condor/bin/condor_wait ${FINALEXTRACT}.filt-${FILTNAME}.clog
endif

#now a db should be ready to go!
echo "set DBNAME = `head -n 1 ${FINALEXTRACT}.filt-${FILTNAME}.log`"
set DBNAME = `head -n 1 ${FINALEXTRACT}.filt-${FILTNAME}.log`
#condorsubmit-stderr-noevict.sh 1 ${DBNAME}.${MERNAME}.explog ${MERNAME} ${DBNAME}
#lets get the worker bees in action
#source /nfs/islpc7_2/ashishv/research/branches/arv-dev/tools/SBMT/dist/mt-64.sh
#runbees.pl --mersc ${MERNAME} --numbees 25 --expdir ${EXPDIR} --scaling 0.455041_1.43918_0_-0.559342_0.0684391_0.00349017_0.0514772_-0.0543193_0_0.0319432_0_-0.138123_0.144261_0.0523467_-0.302114_0_0_0.0179236_0_0.213643_-0.0149665_0.00_0.00_-0.0878697_0.158133_0.00_0.00 --db ${DBNAME}  --timeout 480 

