#!/usr/bin/env perl                                                                                                         
#Run the refiner with default settings                                                                                                 
my $EXPNAME = "grow-diag-final"; #this will create the working directory for output files
my $OUTPOSTFIX = "refined"; #the calling script can look for $EXPNAME/*.$OUTPOSTFIX

my $PART = $ARGV[0]; #got the part 
my $NUMLINES = $ARGV[1]; #the expected number of sentence processed

#first check if the file already exists
if (-e "$PART.$OUTPOSTFIX"){
    my $numLines = `wc -l ${PART}.${OUTPOSTFIX}`;
    if ($NUMLINES==$numLines){
	#remove any lingering clog files so that another process isn't waiting for it
	print `rm cond${PART}*.clog`;
	exit(1);
    }
}


#for refinement, the part you are recieving is a pasted together 
print `cat ${PART} | separatestream.pl "###" ${PART}.ref.input 2`;

my $runme = "refiner.py ${PART}.ref.input.0 ${PART}.ref.input.1 > ${PART}.${OUTPOSTFIX}";
#if you have condor, then add some quotes to the runline and submit thru condor - this will allow the script to terminate
if (defined ($ENV{'CONDOR_SMALL'})){
    my $condor = "\$CONDOR_SMALL 1 cond${PART}";
    $runme  = $condor." \" ".$runme." \" ";
}
print STDERR "$runme\n";
print `$runme`;



