#!/usr/bin/env perl
#Runs the extractor.py on the refined db in parts
#Env requirements: CONDOR_SMALL
#Args[0] $setSize (number of sentences you want extracted
#Args[1] $dataset (the refined data set)
#Args[2] $outputdir (where you want the output to be written to)
#Args[3,4] max initial phrase length, max final phrase length
use strict;
use Getopts::Long;

my $numSentences = $ARGV[0];
$numSentences = $numSentences*3;
my $dataset = $ARGV[1];
my $outputdir = $ARGV[2];

my $maxphraselent = $ARGV[3]; #10
my $maxfinallen = $ARGV[4]; #5

#find out how big the data set is
my @datasizeParts = split(/\s+/,`wc -l $dataset`);
my $datasize = $datasizeParts[0];

print STDERR "Running phrase extract on $datasize lines in parts of size $numSentences\n";

my $condor_small = $ENV{'CONDOR_SMALL'};
my $extractor = `which extractor.py`;
die "ERROR: Condor submission script is not defined in env: CONDOR_SMALL"  if (!defined($condor_small));
die "ERROR: extractor not available in which" if ($extractor !~ m/extractor/);


my $submit = "$condor_small 1 $outputdir/ext-part";
my $cmd = "$extractor -L $maxphraselent -l $maxfinallen -o $outputdir/multi";
my $i = 1;
my $part = 0;
while ($i<$datasize){
    my $runme =  "$submit".$part." \"sed -n \'$i,",$i+$numSentences-1,"p\' $dataset | $cmd".$part."\"\n";
    print STDERR "$runme";
    `$runme.sh`
    $i+=$numSentences;
    $part++;
}

