#!/usr/bin/env perl

# this preprocessing script manipulates the data to satisfy all assumptions made by our SBMT rule extraction and translation system
# no Unicode support
#use bytes;

while (<>) {
  chomp; # get rid of the newline symbol (will otherwise disturb us when removing multiple whitespace below)
  s/(\. *)(\. *)+/ /g; # remove .. ... .... etc. because Charniak's parser cannot handle them correctly
  # Charniak's parser causes a segmentation fault on sentence: 
  # but i wonder what do you dream of now ! ! ! ! ! ! ! ! ! ! ? ? ? ? ? ? ? ? ? ? ?
  # the following two lines try to avoid that problem
  s/(\! *)+/$1/g;
  s/(\? *)+/$1/g;
#  s/\$num/2/gi; # $num/$NUM tag substitution
#  s/\b'/ '/g; # to match words of target sentences to words of charniak's parses, we have to change e.g. "it's" to "it 's"
#  s/\B\.\B//g; # optional:remove dot unless preceded or followed by a
               # letter or number (we just add a dot glue rule in
               # filterrules.pl to handle dots occurring in the
               # testing data)
  s/\#|\B\@//g; # remove all occurrences of # (rule split symbol), and all @ that are not preceded by a letter or number
#  s/[\s\x00-\x20]+/ /g; # normalize whitespace ([ \t\n\r\f]) and control
               # characters to space character, shrink multiple
               # whitespace to one
  s/[\s\x00-\x20]+/ /g; # normalize whitespace ([ \t\n\r\f]) and control
               # characters to space character, shrink multiple
               # whitespace to one
  s/^\s+|\s+$//g; # remove leading or trailing whitespace
#  s/(^|\. *|\! *|\? *)(.)/$1\l$2/g; # lowercase first word of a sentence (optional)
  s/^$/\./g; # Charniak's parser cannot handle empty lines. If line is empty, put a single dot there
  print "$_\n"; # print out the modified line, followed by a newline symbol
}
