#!/bin/perl
#Takes a file sorted by #src words in the format
# #src phrase-table line
# and produce a version with discounted scores

$smallestprob = 0.000000001;

#relative frequencies (conditioned on source) for each source
%sourceHash = ();

open(OUTPUT, ">$ARGV[0]") or die "Unable to open $ARGV[0] for writing";

$linecount  = 0;
while (<STDIN>){
    $linecount++;
    my $oneLine = $_;
    chomp($oneLine);
    if ($oneLine =~ m/([0-9]+)\s+\@(.*) \# (.*) \# (.*) \# (.*)/){

        @scores = split(/ /, $5);


	#split source into words 
	 @sourceWords = split(/ /, $3);

	#split target into words 
	 @targetWords = split(/ /, $4);

	#create Hashentry for current phrase pair
	$currentphrasepair = "$3#$4";

	#just for debugging
	$sourcelength = $1;

	my $lengthsource = scalar(@sourceWords);	
	my $lengthtarget = scalar(@targetWords);

	#iterate thru number of possible  splittings
	my $discount = 0;
	for (my $g=2; $g<=min($lengthsource,$lengthtarget); $g++){
		$discount += addsplittings($g,1,$lengthsource,1,$lengthtarget);
	}

	$adjustedscore = max($smallestprob, $scores[2]- $discount);	
	$sourceHash{$currentphrasepair} = $adjustedscore;
	
	
	#write that prob back to the phrase table
	if ($1!=1){
	    print "$oneLine\n";

	    print "Line: $linecount, NumSrc: $1 Source: $3 Target: $4 Scores: $5\n";
	    print "scores[2] $scores[2] discount $discount adjustedscore $adjustedscore", "\n";

	    print OUTPUT "\@$2 \# $3 \# $4 \# $scores[0] $scores[1] $adjustedscore $scores[3] $scores[4]\n\n" ;
	    print  "\@$2 \# $3 \# $4 \# $scores[0] $scores[1] $adjustedscore $scores[3] $scores[4]\n\n" ;
	}
    }

}
sub min{
    my ($left, $right) = @_;
    #print "left $left right $right", "\n";
    if ($left < $right){
	return $left;
    }else{
	return $right;
    }
}
sub max{
    my ($left, $right) = @_;
    #print "left $left right $right", "\n";
    if ($left > $right){
	return $left;
    }else{
	return $right;
    }
}



sub addsplittings
{
       if ($sourcelength >= 1) {
	   print "@_";
       }
    my ($nsplittings, $sourcestart, $sourceend, $targetstart, $targetend) = @_;
    my $discount = 0;
    if ($nsplittings == 1){
	my @sourcepiece = @sourceWords[$sourcestart-1..$sourceend-1];
	my @targetpiece = @targetWords[$targetstart-1..$targetend-1];
	my $sourceString = join(" ", @sourcepiece);	
	my $targetString = join(" ", @targetpiece);
	$discount = getphraseprob("$sourceString#$targetString");
    } else{
	#$ssep indexes the end of current phrase
	for (my $ssep = $sourcestart; $ssep <= $sourceend-$nsplittings+1; $ssep++)
	{
	    #$tsep indexes the end of current phrase
	    for (my $tsep = $targetstart; $tsep <= $targetend-$nsplittings+1; $tsep++)
	    {
		#lookup phrase $start,...,$sep
		my @sourcepiece = @sourceWords[$sourcestart-1..$ssep-1];
		my @targetpiece = @targetWords[$targetstart-1..$tsep-1];
		my $sourceString = join(" ", @sourcepiece);	
		my $targetString = join(" ", @targetpiece);
		my $currentphraseprob = getphraseprob("$sourceString#$targetString");
		if ($currentphraseprob != 0){
		    $discount += $currentphraseprob * addsplittings($nsplittings-1,$ssep+1,$sourceend,$tsep+1,$targetend);		    
		}
	    }
	}
    }
    return $discount;
}

sub getphraseprob
{
    my ($phr) = @_;
    $res = $sourceHash{$phr};
    if (!exists( $sourceHash{$phr} )){
	$res = 0.0;
    }
    if ($sourcelength >= 1) {
	print "looking up $phr in sourceHash yields: $res\n"
	}

 
	return $res;

}
