#!/usr/bin/env perl
#Take a giza file in STDIN and split it into batches of X sentence. Each batch of sentences is parsed with the 
#parser cmd line provided and phrase and rule extraction is performed (using the key setting specifed in this file)
#
use IO::File;
use strict;

my $numLines = $ARGV[0];
my $devandtest = $ARGV[1];
my $lex = $ARGV[2];
my $lexrev = $ARGV[3];
my $firststep  = $ARGV[4];
my $dir = $ARGV[5]; #output file directory

my $writefiles = 1;

my $altRoot = "alt";
my $parseRoot = "parse";

my $count =0;

if (!(-e $dir)){
    my $runline = "mkdir $dir\n";
    print "RUN: $runline\n";
    system($runline);
}


my $altFileName = "$dir/$altRoot.$count";
my $parseFileName = "$dir/$parseRoot.$count";
my $altfd = new IO::File($altFileName, "w") or die "Unable to open file $altFileName\n";
my $parsefd = new IO::File($parseFileName, "w") or die "Unable to open file $parseFileName\n";

my $lineNumber = 0;
while (<STDIN>){
    my $header = $_;
    my $tgt = <STDIN>;
    my $srcAndAlt = <STDIN>;
    
    #write info into appropriate files
    $altfd->print("$header");
    $altfd->print("$tgt");
    $altfd->print("$srcAndAlt");
    
    $parsefd->print("$tgt");   

    $lineNumber++;
    #schedule and move onto the next file if you hit the limit
    if ($lineNumber==$numLines){
	$altfd->close();
	$parsefd->close();

	#schedule the job
	my $runpipeline = "parseandextract.sh $altFileName $parseFileName $dir $devandtest $lex $lexrev $firststep";
	print "RUN $runpipeline &\n";
	system("$runpipeline");
	$lineNumber=0;
	$count++;

	$altFileName = "$dir/$altRoot.$count";
	$parseFileName = "$dir/$parseRoot.$count";
	$altfd = new IO::File($altFileName, "w") or die "Unable to open file $altFileName\n";
	$parsefd = new IO::File($parseFileName, "w") or die "Unable to open file $parseFileName\n";
	
    }
    
}
