#!/usr/bin/env perl
use strict;
use Getopt::Long;
use IO::File;

my $outfile;
my $numrefs;

die if !GetOptions("outfile=s", \$outfile, "numrefs=s" => \$numrefs);
die "Usage: cat refs | splitreffiles.pl --outfile file --numrefs X" if ((!$outfile)||(!$numrefs));

my @outfiles;
for (my $i=0; $i<$numrefs; $i++){
    push @outfiles, new IO::File("$outfile.$i", "w");
}
while (<STDIN>){
    my $line = $_;
    chomp($line);
    $outfiles[0]->print("$line\n");
    for (my $i=1; $i<$numrefs; $i++){
	$line = <STDIN>;
	chomp($line);
	$outfiles[$i]->print("$line\n");
    }
}
