#!/usr/bin/env perl
#Make the refined alignment have only uniq alignments
# Sentence pair (1) source length 8 target length 7 alignment score : 0.962879 # Sentence pair (1) source length 7 target length 8 alignment score : 0.403436
#when does the train for Paris leave ?
#SRC alignment stuff
use strict;

my $lastsentence = 0;
my @block = ();
while (<STDIN>){
    my $line = $_;
    chomp($line);
    if (/Sentence pair \(([0-9]+)\).*/){
	my $currentsentence = $1;
	#print "Header: $_\n";
	if ($currentsentence!=$lastsentence){
	    #process and print what you have accumulated so far
	    my ($kept, $dropped) = processAndPrintBlock(\@block);
	    print STDERR "Ratio ($lastsentence): ", $kept/($kept+$dropped), "\n" if ($kept+$dropped>0) && ($lastsentence%1000==0);
	    @block = ();
	    $lastsentence = $currentsentence;
	}
	push(@block, $line);
    }else{
	push(@block, $line);
    }
}
my ($kept, $dropped) = processAndPrintBlock(\@block);
print STDERR "Ratio ($lastsentence): ", $kept/($kept+$dropped), "\n" if ($kept+$dropped>0);
#process and print what you have accumulated so far

sub processAndPrintBlock{
    my ($block_aref) = @_;
    #has a set of alignments, all for the same sentence. only print out those that have unique aligments
    my %unique_alts = ();
    my $kept = 0;
    my $dropped = 0;
    #print "BLOCK START ====================== \n";
    for (my $i=0; $i<scalar(@block); $i+=3){
	my $header = $block[$i];
	my $tgt = $block[$i+1];
	my $src = $block[$i+2];
	#print "CHECKING: $src\n";
	if (!defined($unique_alts{$src})){
	    print $header, "\n", $tgt, "\n", $src, "\n";
	    $unique_alts{$src} = 1;
	    $kept++;
	}else{
	    #print "DROPPING: ", $header, $tgt, $src, "\n";
	    $dropped++;
	}
    }
    #print STDERR "Ratio: ", $kept/($kept+$dropped), "\n" if ($kept+$dropped>0);
    return ($kept, $dropped);
}
