#include <MetricSearch.hh>

MetricSearch::MetricSearch(){

}

/*
RawCounts MetricSearch::initRawCounts(int N){
  RawCounts raw;
  for (int n=0; n<N; n++){
    raw.numCorrect[n] = 0;
    raw.numSuggested[n] = 0;
  }
  raw.referenceLengths = 0;
  return raw;
}
*/

/*
void MetricSearch::IncrementRawCounts(RawCounts& rawCounts, int N, Counter* correct, Counter* suggested, double* refLengths){
  for (int n=0; n<N; n++){
    rawCounts.numCorrect[n]+=(*correct)[n];
    rawCounts.numSuggested[n]+=(*suggested)[n];
  }

  rawCounts.referenceLengths += (*refLengths);
}
*/

// returns v2-v1
/*
void MetricSearch::getCounterDifference(Counter v1, Counter v2, Counter& diff, int N){

  for (int n=0; n<N; n++){
    diff[n] = v2[n] - v1[n];    
  }

}
*/

pair<double, RawCounts> MetricSearch::singleSentenceOracle(RawCounts raw, Configuration config, const AllSentRawCountsVector& nBestLists, int sentenceNumber){

  int initialBestIndex = config[sentenceNumber];
  int numCands = nBestLists[sentenceNumber]->size();

  /*

  //dont need this anymore, as long as we have access to the RawCounts we can operate on that object
  vector<Counter*> numberCorrect = nBestLists[sentenceNumber]->getNumberCorrectList();
  vector<Counter*> numberSuggested = nBestLists[sentenceNumber]->getNumberSuggestedList();
  vector<double*> closestRefLength = nBestLists[sentenceNumber]->getReferenceLengthsList();
  */

  vector<RawCounts*>* pAllRawCounts = nBestLists[sentenceNumber];
  cout<<"numraw: "<<pAllRawCounts->size()<<endl;
  assert(pAllRawCounts->size() == numCands);
  
  // start with the current score, see if it goes up
  double bestScore = getMetricScore(raw);
  RawCounts bestCounts = raw;
  int bestIndex = initialBestIndex;

  RawCounts workingCounts  = raw - *((*pAllRawCounts)[initialBestIndex]);

  for (int i=0; i<numCands; i++){
    
    //for all the other candidates
    if (i!=bestIndex){
      
      //add this candidate to the counts
      RawCounts newCounts = workingCounts + *((*pAllRawCounts)[i]);
      double newScore = getMetricScore(newCounts);

      if (newScore>bestScore){
	bestScore = newScore; 
	bestIndex = i;
	bestCounts = newCounts;
      }
    }
  }
  pair<double, RawCounts> retPair;
  retPair.first = bestScore;
  retPair.second = bestCounts;

  // see if there is any change
  //cout<<"Initial:"<<currentIndex<<" Final:"<<bestIndex<<endl;
  config[sentenceNumber] = bestIndex;
  return retPair;
}

/*
pair<double, RawCounts> MetricSearch::CalculateMetricNew(RawCounts raw, Counter correctDelta, Counter suggestDelta, double closestLenDelta){
  RawCounts rawNew;
  for (int n=0; n<m_nGramConsidered; n++){
    rawNew.numCorrect[n] = raw.numCorrect[n] + correctDelta[n];
    rawNew.numSuggested[n] = raw.numSuggested[n] + suggestDelta[n];
  }
  rawNew.referenceLengths = raw.referenceLengths+ closestLenDelta;
  //cout<<"NewRefLen:"<<closestLenDelta<<endl;

  //return all the new data
  pair<double, RawCounts> scoreRaw;
  scoreRaw.first = getMetricScore(rawNew);
  scoreRaw.second = rawNew;
  return scoreRaw;
}
*/


RawCounts MetricSearch::getCountsForConfiguration(const AllSentRawCountsVector& nBestLists, Configuration config){
  RawCounts raw;
  for (int s=0; s<nBestLists.size(); s++){
    vector<RawCounts*>* pAllRawCounts = nBestLists[s];
    RawCounts r = *((*pAllRawCounts)[config[s]]);
    raw = raw + r;
  }
  
  return raw;
}

Configuration MetricSearch::getInitialConfiguration(){
  cout<<"About to return config of size:"<<m_numSentences<<endl;
  Configuration conf = new int[m_numSentences];
  for (int i=0; i<m_numSentences; i++){
    conf[i] = 0;
  }
  return conf;
}


Configuration MetricSearch::GetOracleConfiguration(const AllSentRawCountsVector& nBestLists){

  bool madeChanges = true;  

  Configuration initialConfiguration = getInitialConfiguration();
  RawCounts rawHolder = getCountsForConfiguration(nBestLists, initialConfiguration);
  double scoreHolder = getMetricScore(rawHolder);
  
  cout<<"InitialScore:"<<scoreHolder<<" for "<<m_numSentences<<" sentences"<<endl;
  int iterationNumber = 0;
  while (madeChanges){
    madeChanges = false;
    for (int i=0; i<m_numSentences; i++){
      //PrintConfiguration(config);
      pair<double, RawCounts> retPair = singleSentenceOracle(rawHolder, initialConfiguration, nBestLists,i);
      rawHolder = retPair.second;
      if (retPair.first!=scoreHolder){
	scoreHolder = retPair.first;
	madeChanges = true;
      }
    } // one complete iteration done
    cout<<"Iteration:"<<iterationNumber<<" NumCorrect:"<<rawHolder.numCorrect[0]<<" NumSuggested:"<<rawHolder.numSuggested[0]<<" Score:"<<getMetricScore(rawHolder)<<endl;
    iterationNumber++;
  }

  return initialConfiguration;
}



AbstractScore MetricSearch::ScoreConfiguration(const AllSentRawCountsVector& nBestLists, Configuration config){
  RawCounts raw = getCountsForConfiguration(nBestLists, config);
  AbstractScore toRet;
  toRet.push_back(getMetricScore(raw));
  return toRet;
}


/*
ScoreSort MetricSearch::ScoreLocalAlternatives(vector<CTranslationItem>& allTranslations, RawCounts raw){

  ScoreSort sorter;
  
  for (int i=0; i<allTranslations.size(); i++){
    
    RawCounts rawCopy  = raw;
    for (int n=0; n<m_nGramConsidered; n++){
      rawCopy.numCorrect[n] = raw.numCorrect[n]+allTranslations[i].m_scoringData.numCorrect[n];
      rawCopy.numSuggested[n] = raw.numSuggested[n]+allTranslations[i].m_scoringData.numSuggested[n];
    }
    rawCopy.referenceLengths = raw.referenceLengths + allTranslations[i].m_scoringData.referenceLengths;
    double score = getMetricScore(rawCopy);
    
    //insert the score into the return map
    sorter.insert(pair<double, int>(score, i));  
  }
  
  return sorter;  
}


ScoreSort MetricSearch::ScoreLocalAlternatives(vector<CTranslationItem>& allTranslations){

  int currentIndex = 0;
  //initialize with the score from the first sentence
  RawCounts raw = initRawCounts(m_nGramConsidered);
  return ScoreLocalAlternatives(allTranslations, raw);

}
*/

//scoring local metrics only
/*
ScoreSort MetricSearch::ScoreLocalAlternatives(CNBest* nBest){
  vector<CNBest*> nBestLists;
  nBestLists.push_back(nBest);
  Configuration conf = new int[1];
  conf[0] = 0;
  int numCands = nBest->m_TransducerItems.Size();
  int currentIndex = 0;
  
  vector<Counter*> numberCorrect = nBest->getNumberCorrectList();
  vector<Counter*> numberSuggested = nBest->getNumberSuggestedList();
  vector<double*> closestRefLength = nBest->getReferenceLengthsList();
  RawCounts raw = buildRawCounts(nBestLists, conf, m_nGramConsidered);
  ScoreSort sorter;

  for (int i=0; i<numCands; i++){
    Counter correctDelta;
    getCounterDifference((*(numberCorrect[currentIndex])), (*(numberCorrect[i])), correctDelta, m_nGramConsidered);
    Counter suggestedDelta; 
    getCounterDifference((*(numberSuggested[currentIndex])), (*(numberSuggested[i])), suggestedDelta, m_nGramConsidered);
    double closestRefLengthDelta = (*(closestRefLength[i]))- (*(closestRefLength[currentIndex]));
    
    //pair<double, RawCounts> scoreRaw = CalculateBleuNew(raw, correctDelta, suggestedDelta, closestRefLengthDelta);
    pair<double, RawCounts> scoreRaw = CalculateMetricNew(raw, correctDelta, suggestedDelta, closestRefLengthDelta);

    //insert the score into the return map
    sorter.insert(pair<double, int>(scoreRaw.first, i));  
  }
    
  delete [] conf;  
  return sorter;
}
*/

/*
ScoreSort MetricSearch::ScoreLocalAlternatives(vector<CNBest*>& nBestLists, Configuration conf, int sentenceNumber){
  
  int currentIndex = conf[sentenceNumber];
  int numCands = nBestLists[sentenceNumber]->m_TransducerItems.Size();
  vector<Counter*> numberCorrect = nBestLists[sentenceNumber]->getNumberCorrectList();
  vector<Counter*> numberSuggested = nBestLists[sentenceNumber]->getNumberSuggestedList();
  vector<double*> closestRefLength = nBestLists[sentenceNumber]->getReferenceLengthsList();
  RawCounts raw = buildRawCounts(nBestLists, conf, m_nGramConsidered);

  ScoreSort sorter;

  for (int i=0; i<numCands; i++){
    Counter correctDelta;
    getCounterDifference((*(numberCorrect[currentIndex])), (*(numberCorrect[i])), correctDelta, m_nGramConsidered);
    Counter suggestedDelta; 
    getCounterDifference((*(numberSuggested[currentIndex])), (*(numberSuggested[i])), suggestedDelta, m_nGramConsidered);
    double closestRefLengthDelta = (*(closestRefLength[i]))- (*(closestRefLength[currentIndex]));
    
    //pair<double, RawCounts> scoreRaw = CalculateBleuNew(raw, correctDelta, suggestedDelta, closestRefLengthDelta);
    pair<double, RawCounts> scoreRaw = CalculateMetricNew(raw, correctDelta, suggestedDelta, closestRefLengthDelta);

    //insert the score into the return map
    sorter.insert(pair<double, int>(scoreRaw.first, i));  
  }
  return sorter;

}
*/

//implementation doesnt do anything here, it needs to beextended
// void MetricSearch::ScorePairwise(CTranslationItem& hyp, CTranslationItem& ref, RawCounts& raw){  }

//need to extend this to allow scoring without an nbest list
/*
AbstractScore MetricSearch::ScoreTranslationRun(vector<string>& translationSet, vector<CNBest*>& nBestLists){
  int sentenceNumber = 0;
  
  //the counts object for this scoring
  RawCounts raw = initRawCounts(m_nGramConsidered);
  for (vector<string>::iterator iter = translationSet.begin(); iter!= translationSet.end(); ++iter){
    cout<<"Scoring:"<<(*iter)<<endl;
    CNBestItem* oneItem = nBestLists[sentenceNumber]->GetNBestItem(stringToVocabVector(*iter));

    // add its counts and references to the raw counts object
    Counter* correctCNT = oneItem->getNumberCorrect();
    Counter* suggestedCNT = oneItem->getNumberSuggested();
    for (int n=0; n<m_nGramConsidered; n++){
      raw.numCorrect[n] += (*correctCNT)[n];
      raw.numSuggested[n] += (*suggestedCNT)[n];
    }
    raw.referenceLengths += *(oneItem->getClosestRefLength());
  
    sentenceNumber++;
  }
  
  cout<<"Raw:";
  for (int n=0; n<m_nGramConsidered; n++){
    cout<<n+1<<":"<<raw.numCorrect[n]<<"/"<<raw.numSuggested[n]<<" ";
  }
  cout<<" Ref:"<<raw.referenceLengths<<endl;
  
  double finalScore=getMetricScore(raw);
  // score the raw counts associated with this translation bank

  
  //if (m_scoringType == "NIST"){
  //  double myscore = getNISTScore(raw);    
  //  finalScore= myscore;
  //}else{
  //  double myscore = getBleuScore(raw);    
  //  finalScore = myscore;
  //}
  
  
  
  AbstractScore toRet;
  toRet.push_back(finalScore);
  return toRet;
}
*/

vector<CWordIndex>& MetricSearch::GetReference(int sentenceNumber, int referenceNumber){
  return (m_referenceBank[sentenceNumber])[referenceNumber];
}

vector< vector<CWordIndex> >& MetricSearch::GetAllReferences(int sentenceNumber){
  return (m_referenceBank[sentenceNumber]);
}

CCompactTSequence<int>* MetricSearch::CollectNGramsBase(vector<int> source, int maxNSize){


  CCompactTSequence<int>* pPhraseCollection = new CCompactTSequence<int>();
  pPhraseCollection->Init(m_pVoc);

  //list of sizes to match the n-gram collected 
  std::vector< pair<int, int> > gramSizes;

  int size = source.size();

  
  for (int n=1; n<=maxNSize; n++){

    // where to start searching from
    for (int i=0; i<=size-n; i++){

      //string accumulated = "";
      vector<int> sequence;
      for (int j=0; j<n; j++){
	//foundGram.push_back(source[i+j]);
	//accumulated = accumulated + source[i+j];
	sequence.push_back(source[i+j]);
	
	/*
	if (j+1<n){
	  accumulated += " ";
	}
	*/
      }
      pPhraseCollection->InsertPhrasePair(sequence, 1);
    }
  }
  return pPhraseCollection;
}

vector<CWordIndex> MetricSearch::stringToVocabVector(string str){
  vector<CWordIndex> toRet;
  stringstream ss(stringstream::in | stringstream::out);
  ss<<str;
  while (!ss.eof()){
    string tmp;
    ss>>tmp;
    //int index = m_pVoc->GetIndex(CString(tmp.c_str()));
    int index = m_pVoc->GetIndex(tmp);
    //if the word is not in the vocab, add it
    //az:done automatically now
    //    if (index==CVocabulary::UNK){
    //      index = m_pVoc->AddWord(tmp);
    //      cerr<<" Adding word to vocab (in EditSearch reference building): "<<tmp<<" @ "<<index<<endl;
    //    }
    toRet.push_back(index);
  }
  return toRet;
}



void MetricSearch::BuildReferences(const char* fileName, redi::pstream& pbuf, bool normalizeReference, const int numReferences, CVocabulary* pVoc){
  
  if (fileName!=NULL){
    
    ifstream fp(fileName);
    if (!fp.good()){
      cout<<"Unable to open reference file listing:"<<fileName<<endl;
      exit(-1);
    }
    cout<<"Loading:"<<fileName<<endl;
    char buf[10000];
    buf[0] = '\0';

    int sentenceNumber = -1;
    for (; !fp.eof(); ){


      vector<string> referenceSet;

      //prepare for this bank of setences
      vector<VocabVector> v; //v represents all the references for one sentence
      m_referenceBank.push_back(v);
      sentenceNumber++;
      //      cout<<"Ref:"<<sentenceNumber<<"numReferences:"<<numReferences<<endl;

      for (int r=0; r<numReferences; r++){ 

	fp.getline(buf, 10000);
	//cout<<"READ:"<<buf<<" length="<<strlen(buf)<<endl;
	while ((strlen(buf)==0) && !(fp.eof())){
	  fp.getline(buf, 10000);
	}
	if (fp.eof()){
	  break;
	}
	//cout<<"BeforeToEnterRef:"<<buf<<"#"<<endl;
	//added to do normalizing - global function
	string sourceWord=string(buf);
	if (pbuf.good() && normalizeReference){
	  cout<<"WARNING: normalizing reference\n";
	  pbuf<<sourceWord<<"\n\r";
	  pbuf.flush();

	  std::string str;
	  //pbuf.getLine();
	  //cout<<"original: "<<sourceWord<<endl;
	  std::getline(pbuf.out(), str);
	  //cout<<"returnString:"<<str<<endl;
	  sourceWord = str;
	  //cout<<"after: "<<sourceWord<<endl;
	  
	}




	//cout<<"AfterNorm:"<<sourceWord<<"#"<<endl;
	int Pos = 0;
	int NextPos = 0;
	
	VocabVector oneSentV;
	m_referenceBank[sentenceNumber].push_back(oneSentV);
	
	do{
	  NextPos = sourceWord.find(' ', Pos);
	  string Word = sourceWord.substr(Pos, NextPos-Pos);
	  //cout<<"Checking vocabword:"<<Word<<endl;
	  //if (pVoc->GetIndex( CString( Word.c_str()))==pVoc->UNK){
	  //if (pVoc->GetIndex(Word)==pVoc->UNK){
	    //cout<<"Adding Word:"<<Word<<endl;
	  //pVoc->AddWord(string(Word));
	  //}
	  //int wIndex = pVoc->GetIndex(CString( Word.c_str()));
	  //int wIndex = pVoc->GetIndex(Word);
	  int wIndex = pVoc->AddWord(Word);
	  (m_referenceBank[sentenceNumber])[r].push_back(wIndex);
	    
	  Pos = NextPos + 1;
	  
	}while (NextPos >= 0);
	

	//	cout<<"ToEnterRef:"<<sourceWord<<"#"<<endl;
	referenceSet.push_back(sourceWord);

      }
      /*
      //this is specific to BleuSearch
      if (referenceSet.size()!=0){
	//cout<<"about to process refs of size="<<referenceSet.size()<<endl;
	m_referenceList.push_back(ProcessReferences(referenceSet));
	//PrintHashElements(m_referenceList.size()-1);
	
      }
      */
    
    }
    fp.close();
  }

  //since we load up an initial reference immediately
  if (m_referenceBank[m_referenceBank.size()-1].size()==0){
    m_referenceBank.pop_back();
  }
  //just transfered over from the input parameters
  m_numReferences = numReferences;
  
}
