#ifndef __TERSearch__
#define __TERSearch__

#include <MetricSearch.hh>
#include <Vocabulary.hh>
#include <vector>

//The class doing all the work!
#include <EvaluatorTER.hh>

class TERSearch : public MetricSearch{

protected:
  
  Score m_maxScore; //!< highest value that this score can take
  Score m_minEpsilon; //!< smallest value that constitutes a reasonable difference in score
  
public:

  TERSearch(const char* referenceListFile, redi::pstream& pbuf, bool normalizeReference, const int numReferences, CVocabulary* pVoc);
  TERSearch();

  /**
   * Scoring virtual function implementations
   */
  
  //================================================================
  // Virtual functions as required by MetricSearch
  //================================================================
  //efficient version that allows you to save the gram data structures
  void ScorePairwise( CCompactTSequence<int>* hypNGrams,  CCompactTSequence<int>* refNGrams,  int refLength,RawCounts& raw);
  
  void ScoreSingleHyp(const int sentenceNumber, string candidate, RawCounts& countObject);


  Score getMetricScore(RawCounts& raw);

  AbstractScore getMetricScoreDetailed(RawCounts& raw);

  //the highest score this function can have = 0
  Score maxScore(){
    return m_maxScore;
  }

  Score minEpsilon(){
    return m_minEpsilon;
  }

  
};

#endif
