#include <CompactTSequence.hh>
#include <Types.hh>
using namespace std;


/*
CCompactTSequenceItem::CCompactTSequenceItem(std::vector<CWordIndex> sequence){
  
  m_sequence = sequence;
  m_value = 0.0;
  m_key = -1;
}

CCompactTSequenceItem::~CCompactTSequenceItem(){

}

void CCompactTSequenceItem::SetValue(double value){
  m_value = value;
}

double CCompactTSequenceItem::GetValue(){
  return m_value;
}

double* CCompactTSequenceItem::GetValueAddress(){
  return &m_value;
}

void CCompactTSequenceItem::IncrementValue(double value){
  m_value += value;
}

KeyType CCompactTSequenceItem::GetKey(){
  return m_key;
}

void CCompactTSequenceItem::SetKey(KeyType key){
  m_key = key;
}

std::vector<CWordIndex> CCompactTSequenceItem<class T>::GetSequence(){
  return m_sequence;
}

void CCompactTSequenceItem::PrintSequence(CVocabulary* pVoc){
  for (vector<CWordIndex>::iterator iter=m_sequence.begin(); iter!=m_sequence.end(); ++iter){
    cout<<(const char*)(pVoc->GetWord(*iter));
    if (iter!=m_sequence.end()-1){
      cout<<" ";
    }
  }
}

*/

/*
CCompactTSequence::CCompactTSequence(){
  s_NotFound = -1;  
  m_NumberOfStatesSource=0;
}

CCompactTSequence::~CCompactTSequence(){
  for(sgi::hash_map< CTransducerState , CCompactTSequenceItem<double>* >::iterator iter= m_EmissionTableSource.begin(); iter!=m_EmissionTableSource.end(); ++iter){
    CCompactTSequenceItem<double>* item = (*iter).second;
    delete item;
  }
  m_EmissionTableSource.clear();
}


void CCompactTSequence::Init(CVocabulary* pInputVocabulary){
  m_pVoc = pInputVocabulary;
}

CCompactTSequenceItem<double>* CCompactTSequence::InsertPhrasePair(std::vector<CWordIndex> sequence, double value){
 
  //sets up the trie to accept new sequences
  m_BuildMode = true;
  
  CTransducerState State = 0;
  CTransducerState NextState = 0;
  
  for(std::vector<CWordIndex>::iterator iter = sequence.begin(); iter!=sequence.end(); ++iter){
    if (NextSource( State, (*iter), NextState ) == 0) {
      std::cout << "CTransducer::BuildSourceTables: Warning: NextSource() returned 0 (whatever this means)" << std::endl;
    }
    State = NextState;
  }

  //state now holds the transducer state for the final word
  if (m_EmissionTableSource.count(NextState)==0){
    CCompactTSequenceItem<double>* oneItem = new CCompactTSequenceItem<double>(sequence);
    oneItem->SetValue(value);
    m_TransducerItems.Append(oneItem);
    m_EmissionTableSource[NextState] = oneItem;
    return oneItem;
  }else{
    CCompactTSequenceItem<double>* oneItem = m_EmissionTableSource[NextState];
    //oneItem->IncrementValue(value);
    oneItem->SetValue(oneItem->GetValue() + value);
    return oneItem;
  }
}

CCompactTSequenceItem<double>* CCompactTSequence::GetCompactTSequence(std::vector<CWordIndex> sequence){
  m_BuildMode = false;

  CTransducerState State = 0;
  CTransducerState NextState = 0;
  
  for(std::vector<CWordIndex>::iterator iter = sequence.begin(); iter!=sequence.end(); ++iter){
    if (NextSource( State, (*iter), NextState ) == 0) {
      //std::cout << "CTransducer::BuildSourceTables: Warning: NextSource() returned 0 (whatever this means)" << std::endl;
      return NULL;
    }
    State = NextState;
  }

  return m_EmissionTableSource[ NextState ];
}

//defaults to returning 1.0
CCompactTSequenceItem<double>* CCompactTSequence::GetCompactTSequenceLexical(CWordIndex e, CWordIndex f){
  std::vector<CWordIndex> sequence;
  sequence.push_back(e);
  sequence.push_back(f);
  CCompactTSequenceItem<double>* item = GetCompactTSequence(sequence);
  return item;
}

int CCompactTSequence::NumItems(){
  return m_TransducerItems.Size();
}
void  CCompactTSequence::DisplayAllItems(){
  for (int i=m_TransducerItems.MinIndex(); i<=m_TransducerItems.MaxIndex(); i++){
    CCompactTSequenceItem<double>* item = m_TransducerItems[i];
    cout<<"SeqKey: "<<item->GetKey()<<" ";
    item->PrintSequence(m_pVoc);
    cout<<" Value: "<<item->GetValue()<<endl;
  }
}
void CCompactTSequence::DisplayNonZeroItems(){
  for (int i=m_TransducerItems.MinIndex(); i<=m_TransducerItems.MaxIndex(); i++){
    CCompactTSequenceItem<double>* item = m_TransducerItems[i];
    if (item->GetValue()!=0){
      cout<<"SeqKey: "<<item->GetKey()<<" ";
      item->PrintSequence(m_pVoc);
      cout<<" Value: "<<item->GetValue()<<endl;
    }
  }
}

void CCompactTSequence::ClearAll(){
  for (int i=m_TransducerItems.MinIndex(); i<=m_TransducerItems.MaxIndex(); i++){
    CCompactTSequenceItem<double>* ptr = m_TransducerItems[i];
    delete ptr;
    ptr = NULL;
  }
  m_TransducerItems.Clear();
  m_EmissionTableSource.clear();
  m_TransitionTableSource.clear();
  
}

int CCompactTSequence<class T>::NextSource( CTransducerState State, CWordIndex Word, CTransducerState &NextState )
{

  Trace( 1, "CTransducer::NextSource " << State << " " << Word );

  // if in BuildMode we make new entry into transition table
  // otherwise: error

  CTSStateWord StateWord( State, Word );
  //cout<<"\tSTWord State:"<<State<<" Word:"<<Word<<endl;
  std::map< CTSStateWord, CTransducerState, CompareTStateWord >::const_iterator IterState;
  IterState = m_TransitionTableSource.find( StateWord );

  if ( IterState == m_TransitionTableSource.end() ) {
    if ( m_BuildMode ) {
      m_NumberOfStatesSource++;
      NextState = m_NumberOfStatesSource;
      m_TransitionTableSource[ StateWord ] = NextState;
      //cout<<"\tInsert " << State 
      //     			 << " " << m_pVoc->GetWord( Word ) 
      //  << " " << NextState<<endl;
      
    } else {
      //std::cout << "ERROR: in CTransducer::Next" << std::endl
      //<< "ERROR: State " << State << " is not in the transition table" << std::endl;
      NextState = s_NotFound;
      return 0;
    }
  }else {
    //cout<<"\tFound " << m_pVoc->GetWord( IterState->first.m_WordIndex ) 
    //	   << " leading from state " << IterState->first.m_State 
    //	<< " to state " << " " << IterState->second<<endl;
	NextState = IterState->second;
  }

  return 1;
  
}

*/

