#ifndef Rule_hh
#define Rule_hh

#include <vector>
#include <list>
#include <Vocabulary.hh>


//namespace CRuleNamespace {
/*
namespace {
//  int C_NumModelsTM; //number of tm models represented in each hyp:
			//glue feature, word count, phrase count (1),
			//RF|Result, RF|Target, RF|Source,
			//OccurrenceCount, ...
//  int C_NumModelsTotal; //!number of models represented in each hyp (LM + TMs)
};
*/

//using namespace CRuleNamespace;

using namespace std;

typedef vector<CWordIndex> CWordSequence;

class CRule {

public:
  
  CWordIndex m_productionResult;
  
  CWordSequence m_translationOutput;

  std::vector<float> m_negLogProbs;

  string m_rule;

  static CVocabulary* pVoc; //! statically shared vocab for all rules

  static int C_NumModelsTM; //number of tm models represented in each hyp:
  //glue feature, word count, phrase count (1),
  //RF|Result, RF|Target, RF|Source,
  //OccurrenceCount, ...
  static int C_NumModelsTotal; //!number of models represented in each hyp (LM + TMs)
  static int C_NumLMs; //! number of language models
  static int C_LMLocation; //!location of the forst LM in the list of models
  static int C_GlueLocation; //!location of the Glue feature
  static int C_RuleApplicationCountLocation; //! location of the rule-application count feature
  static int C_SourceSpanPenaltyLocation; //! location of the source span penalty feature if --UseSpanFeatures=1

  //!Constructor to build a rule from scratch
  CRule(const std::string& strkey, const std::string& strdata);

  //!Copy constructor
  CRule(const CRule& r);

  //!Assignment operator
  CRule& operator = (const CRule& r);

  //!Utilty display method for debugging
  void Display();

  //static void Tokenize(const std::std::string& str, std::vector<std::std::string>& tokens, const std::std::string& delimiters = " ");
  
  static void Tokenize(const std::string& str,
		       vector<std::string>& tokens,
		       const std::string& delimiters=" ")
  {
    // Skip delimiters at beginning.
    std::string::size_type lastPos = str.find_first_not_of(delimiters, 0);
    // Find first "non-delimiter".
    std::string::size_type pos     = str.find_first_of(delimiters, lastPos);
    
    while (std::string::npos != pos || std::string::npos != lastPos)
      {
        // Found a token, add it to the vector.
        tokens.push_back(str.substr(lastPos, pos - lastPos));
        // Skip delimiters.  Note the "not_of"
        lastPos = str.find_first_not_of(delimiters, pos);
        // Find next "non-delimiter"
        pos = str.find_first_of(delimiters, lastPos);
      }
  }
  
};

#endif
