#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <fortify.h>
#ifndef __BOOL_H
#define __BOOL_H


//--------------------------------------------------------------------
//
// Datatype BOOL for truth values
//
//--------------------------------------------------------------------

class BOOL {

public:

  BOOL( int = 0);
  operator int() const;

private:

  int m_Value;

}; // BOOL



//========================= Inlines =================================

inline BOOL::BOOL( int i ) {
  m_Value = i ? 1 : 0;
}


inline BOOL::operator int() const {
  return m_Value;
}



// GNU-Compiler has bool, other compilers get it here

#ifndef __GNUC__

typedef BOOL bool;

#endif


//========================= Constants ==============================

#ifdef FALSE
#undef FALSE
#endif
#ifdef TRUE
#undef TRUE
#endif
#ifdef False
#undef False
#endif
#ifdef True
#undef True
#endif


// for the GNU-Compiler
#ifdef __GNUC__

#define TRUE true
#define FALSE false

#define True true
#define False false

#endif // __GNUC__


// for the rest of the world
#ifndef __GNUC__

const BOOL FALSE(0);
const BOOL TRUE(1);

const BOOL False(0);
const BOOL True(1);

const BOOL false(0);
const BOOL true(1);

#endif // !__GNUC__


#endif
