#ifndef __utils_hh__
#define __utils_hh__
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <fortify.h>

#include <stdlib.h>


#define EXIT_IF(C, M, V) {if (C) \
			 {cerr << endl << "ERROR: " << M << "... exiting" << endl; \
			    exit (V);}}

#define ABORT_IF(C, M) {if (C) \
			 {cerr << endl << "ERROR: " << M << "... aborting" << endl; \
			    abort();}}

#define RETURN_IF(C, M, V) {if (C) \
			 {cerr << endl << M  << endl; \
			    return (V);}}

#define MAX(E, A, B) {E = ((A) > (B)) ? (A) : (B);}
#define MIN(E, A, B) {E = ((A) < (B)) ? (A) : (B);}


#endif










